// This code was generated by a tool.
// Processing tool available at https://github.com/mezoni/peg

part of macro_processor.internal.parsers.directive_parser;

int _escape(String ch) {
  switch(ch) {
    case "a":
      return 0x07;
    case "b":
      return 0x08;
    case "f":
      return 0x0c;
    case "n":
      return 0x0a;
    case "r":
      return 0x0d;
    case "t":
      return 0x09;
    case "v":
      return 0x0b;
    case "\'":
      return 0x27;
    case "\"":
      return 0x22;
    case "\?":
      return 0x3f;
    case "\\":
      return 0x5c;
    default:
      throw new StateError("Unknown escape sequence: \\$ch");  
  }
}

FloatingPointLiteral _floatLiteral(String source, int position) {
  var value = _parserFloat(source);
  return new FloatingPointLiteral(position: position, text: source, value: value);
}

SourceFragment _identToFragment(Identifier identifier) {
  return new SourceFragment(position: identifier.position, text: identifier.name, value: new Symbol(identifier.name)); 
}

double _parserFloat(String source) {
  source = source.toLowerCase();
  var hex = false;
  if (source.startsWith("0x")) {
    source = source.substring(2);
    hex = true;
  }
  var length = source.length;
  var endsWith = source[length - 1];
  if (endsWith == "f" || endsWith == "l") {
    source = source.substring(0, length - 1);
  }
  if (!hex) {
    return double.parse(source);
  }
  var index = source.indexOf("p");
  var exponent = int.parse(source.substring(index + 1));
  source = source.substring(0, index);
  index = source.indexOf(".");
  int integer = 0;
  int fractional = 0;
  if (index == 0) {
    fractional = int.parse(source.substring(1), radix: 16);
  } else if (index > 0) {
    integer = int.parse(source.substring(0, index), radix: 16);
    fractional = int.parse(source.substring(index + 1), radix: 16);
  } else {
    integer = int.parse(source, radix: 16);
  }
  var d = double.parse(".$fractional") * .625;
  return (integer + d) * pow(2, exponent);
}

StringLiteral _stringLiteral(String source, List<int> characters, int position) {
  var value = "";
  if (characters != null) {
    value = new String.fromCharCodes(characters);
  }    
  return new StringLiteral(position: position, text: source, value: value);
}

SourceLine _sourceLine(List<SourceFragment> fragments, SourceFragment last, int position) {
  if (last != null) {
    fragments.add(last);
  }
  return new SourceLine(fragments: fragments, position: position); 
}

class MacroParser {
  static final List<String> _ascii = new List<String>.generate(128, (c) => new String.fromCharCode(c));
  
  static final List<String> _expect0 = <String>["eof"];
  
  static final List<String> _expect1 = <String>["\'#define\'", "\'#error\'", "\'#if\'", "\'#ifdef\'", "\'#ifndef\'", "\'#include\'", "\'#undef\'", "new_line", "source_fragment"];
  
  static final List<String> _expect10 = <String>["\'#error\'"];
  
  static final List<String> _expect11 = <String>["new_line", "source_fragment"];
  
  static final List<String> _expect12 = <String>["new_line"];
  
  static final List<String> _expect13 = <String>["identifier"];
  
  static final List<String> _expect14 = <String>["\'#if\'"];
  
  static final List<String> _expect15 = <String>["\'#ifdef\'"];
  
  static final List<String> _expect16 = <String>["\'#ifndef\'"];
  
  static final List<String> _expect17 = <String>["\'#include\'"];
  
  static final List<String> _expect18 = <String>["source_fragment"];
  
  static final List<String> _expect19 = <String>["P", "p"];
  
  static final List<String> _expect2 = <String>["\'#if\'", "\'#ifdef\'", "\'#ifndef\'"];
  
  static final List<String> _expect20 = <String>["\'", "L\'"];
  
  static final List<String> _expect21 = <String>["E", "e"];
  
  static final List<String> _expect22 = <String>["<"];
  
  static final List<String> _expect23 = <String>["/"];
  
  static final List<String> _expect24 = <String>["0X", "0x"];
  
  static final List<String> _expect25 = <String>["\\x"];
  
  static final List<String> _expect26 = <String>["#include"];
  
  static final List<String> _expect27 = <String>["LL", "ll"];
  
  static final List<String> _expect28 = <String>["0"];
  
  static final List<String> _expect29 = <String>["\\"];
  
  static final List<String> _expect3 = <String>[];
  
  static final List<String> _expect30 = <String>["\"", "L\""];
  
  static final List<String> _expect31 = <String>["\\U", "\\u"];
  
  static final List<String> _expect4 = <String>["\'#elif\'"];
  
  static final List<String> _expect5 = <String>["\'#else\'"];
  
  static final List<String> _expect6 = <String>["#endif"];
  
  static final List<String> _expect7 = <String>["\'#define\'", "\'#error\'", "\'#include\'", "\'#undef\'"];
  
  static final List<String> _expect8 = <String>["\'#define\'"];
  
  static final List<String> _expect9 = <String>["\'#undef\'"];
  
  static final List<bool> _lookahead = _unmap([0x7ff80ffd, 0x7ff43fff, 0x7fffffff, 0x7fff4bff, 0x407fefff, 0x1f, 0x7f, 0x8060000, 0x30080000, 0x40000010, 0x1ffa060, 0x3000, 0x180000, 0x200000]);
  
  static final List<bool> _mapping0 = _unmap([0x9]);
  
  static final List<bool> _mapping1 = _unmap([0x20000009, 0x0, 0x100000]);
  
  static final List<bool> _mapping10 = _unmap([0x800001]);
  
  static final List<bool> _mapping11 = _unmap([0x1, 0x2]);
  
  static final List<bool> _mapping2 = _unmap([0x7ff80ffd, 0x7ff43fff, 0x7fff]);
  
  static final List<bool> _mapping3 = _unmap([0x41, 0x82]);
  
  static final List<bool> _mapping4 = _unmap([0x7e03ff, 0xfc0000]);
  
  static final List<bool> _mapping5 = _unmap([0x1, 0x2]);
  
  static final List<bool> _mapping6 = _unmap([0x43ffffff, 0x7fffffe]);
  
  static final List<bool> _mapping7 = _unmap([0x1000009, 0x0, 0x100000]);
  
  static final List<bool> _mapping8 = _unmap([0x5]);
  
  static final List<bool> _mapping9 = _unmap([0x20000021, 0x8000000, 0x544046]);
  
  static final List<int> _strings0 = <int>[35, 101, 110, 100, 105, 102];
  
  static final List<int> _strings1 = <int>[35, 100, 101, 102, 105, 110, 101];
  
  static final List<int> _strings10 = <int>[76, 39];
  
  static final List<int> _strings11 = <int>[92, 120];
  
  static final List<int> _strings12 = <int>[48, 120];
  
  static final List<int> _strings13 = <int>[48, 88];
  
  static final List<int> _strings14 = <int>[35, 105, 110, 99, 108, 117, 100, 101];
  
  static final List<int> _strings15 = <int>[76, 76];
  
  static final List<int> _strings16 = <int>[108, 108];
  
  static final List<int> _strings17 = <int>[76, 34];
  
  static final List<int> _strings18 = <int>[92, 85];
  
  static final List<int> _strings19 = <int>[92, 117];
  
  static final List<int> _strings2 = <int>[35, 101, 108, 105, 102];
  
  static final List<int> _strings3 = <int>[35, 101, 108, 115, 101];
  
  static final List<int> _strings4 = <int>[35, 101, 114, 114, 111, 114];
  
  static final List<int> _strings5 = <int>[35, 105, 102];
  
  static final List<int> _strings6 = <int>[35, 105, 102, 100, 101, 102];
  
  static final List<int> _strings7 = <int>[35, 105, 102, 110, 100, 101, 102];
  
  static final List<int> _strings8 = <int>[13, 10];
  
  static final List<int> _strings9 = <int>[35, 117, 110, 100, 101, 102];
  
  final List<String> _tokenAliases = ["\'#define\'", "\'#elif\'", "\'#else\'", "eof", "\'#error\'", "identifier", "\'#if\'", "\'#ifdef\'", "\'#ifndef\'", "\'#include\'", "new_line", "source_fragment", "\'#undef\'"];
  
  final List<int> _tokenFlags = [1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 1, 1];
  
  final List<String> _tokenNames = ["define", "elif", "else", "eof", "error", "identifier", "if", "ifdef", "ifndef", "include_directive", "new_line", "source_fragment", "undef"];
  
  static final List<List<int>> _transitions0 = [[0, 34, 36, 1114111], [35, 35]];
  
  static final List<List<int>> _transitions1 = [[10, 10, 13, 13]];
  
  static final List<List<int>> _transitions10 = [[0, 47, 58, 1114111], [48, 57]];
  
  static final List<List<int>> _transitions11 = [[46, 46, 48, 57]];
  
  static final List<List<int>> _transitions12 = [[46, 46], [48, 57]];
  
  static final List<List<int>> _transitions13 = [[69, 69, 101, 101]];
  
  static final List<List<int>> _transitions14 = [[69, 69], [101, 101]];
  
  static final List<List<int>> _transitions15 = [[46, 46, 48, 57, 65, 90, 95, 95, 97, 122]];
  
  static final List<List<int>> _transitions16 = [[70, 70, 76, 76, 102, 102, 108, 108]];
  
  static final List<List<int>> _transitions17 = [[48, 57, 65, 70, 97, 102]];
  
  static final List<List<int>> _transitions18 = [[0, 47, 58, 64, 71, 96, 103, 1114111], [48, 57, 65, 70, 97, 102]];
  
  static final List<List<int>> _transitions19 = [[46, 46], [48, 57, 65, 70, 97, 102]];
  
  static final List<List<int>> _transitions2 = [[65, 90, 92, 92, 95, 95, 97, 122]];
  
  static final List<List<int>> _transitions20 = [[0, 47, 58, 64, 91, 91, 93, 94, 96, 96, 123, 1114111], [48, 57], [65, 90, 92, 92, 95, 95, 97, 122]];
  
  static final List<List<int>> _transitions21 = [[65, 90, 95, 95, 97, 122], [92, 92]];
  
  static final List<List<int>> _transitions22 = [[48, 48], [49, 57]];
  
  static final List<List<int>> _transitions23 = [[76, 76, 108, 108], [85, 85, 117, 117]];
  
  static final List<List<int>> _transitions24 = [[76, 76], [108, 108]];
  
  static final List<List<int>> _transitions25 = [[76, 76, 108, 108]];
  
  static final List<List<int>> _transitions26 = [[65, 90, 95, 95, 97, 122]];
  
  static final List<List<int>> _transitions27 = [[0, 47, 56, 1114111], [48, 55]];
  
  static final List<List<int>> _transitions28 = [[43, 43, 45, 45]];
  
  static final List<List<int>> _transitions29 = [[34, 34], [76, 76]];
  
  static final List<List<int>> _transitions3 = [[10, 10], [13, 13]];
  
  static final List<List<int>> _transitions30 = [[85, 85, 117, 117]];
  
  static final List<List<int>> _transitions4 = [[0, 33, 35, 38, 40, 45, 47, 47, 58, 64, 91, 91, 93, 94, 96, 96, 123, 1114111], [34, 34], [39, 39, 46, 46, 48, 57], [65, 75, 77, 90, 92, 92, 95, 95, 97, 122], [76, 76]];
  
  static final List<List<int>> _transitions5 = [[80, 80, 112, 112]];
  
  static final List<List<int>> _transitions6 = [[80, 80], [112, 112]];
  
  static final List<List<int>> _transitions7 = [[0, 42, 44, 44, 46, 1114111], [43, 43, 45, 45]];
  
  static final List<List<int>> _transitions8 = [[39, 39], [76, 76]];
  
  static final List<List<int>> _transitions9 = [[39, 39, 76, 76], [46, 46], [48, 57]];
  
  List<Map<int, List>> _cache;
  
  List<int> _cachePos;
  
  List<bool> _cacheable;
  
  int _ch;
  
  int _cursor;
  
  List<MacroParserError> _errors;
  
  List<String> _expected;
  
  int _failurePos;
  
  List<int> _input;
  
  int _inputLen;
  
  int _startPos;
  
  int _testing;
  
  int _token;
  
  int _tokenStart;
  
  bool success;
  
  final String text;
  
  MacroParser(this.text) {
    if (text == null) {
      throw new ArgumentError('text: $text');
    }    
    _input = _toCodePoints(text);
    _inputLen = _input.length;    
    reset(0);    
  }
  
  void _addToCache(dynamic result, int start, int id) {   
    var map = _cache[id];
    if (map == null) {
      map = <int, List>{};
      _cache[id] = map;
    }
    map[start] = [result, _cursor, success];      
  }
  
  void _failure([List<String> expected]) {  
    if (_failurePos > _cursor) {
      return;
    }
    if (_failurePos < _cursor) {    
      _expected = [];
     _failurePos = _cursor;
    }
    if (_token != null) {
      var alias = _tokenAliases[_token];
      var flag = _tokenFlags[_token];
      var name = _tokenNames[_token];
      if (_failurePos > _tokenStart && _failurePos == _inputLen && (flag & 1) != 0) {             
        var message = "Unterminated '$name'";
        _errors.add(new MacroParserError(MacroParserError.UNTERMINATED, _failurePos, _tokenStart, message));
        _expected.addAll(expected);            
      } else if (_failurePos > _tokenStart && (flag & 1) != 0) {             
        var message = "Malformed '$name'";
        _errors.add(new MacroParserError(MacroParserError.MALFORMED, _failurePos, _tokenStart, message));
        _expected.addAll(expected);            
      } else {
        _expected.add(alias);
      }            
    } else if (expected == null) {
      _expected.add(null);
    } else {
      _expected.addAll(expected);
    }   
  }
  
  List _flatten(dynamic value) {
    if (value is List) {
      var result = [];
      var length = value.length;
      for (var i = 0; i < length; i++) {
        var element = value[i];
        if (element is Iterable) {
          result.addAll(_flatten(element));
        } else {
          result.add(element);
        }
      }
      return result;
    } else if (value is Iterable) {
      var result = [];
      for (var element in value) {
        if (element is! List) {
          result.add(element);
        } else {
          result.addAll(_flatten(element));
        }
      }
    }
    return [value];
  }
  
  dynamic _getFromCache(int id) {  
    if (!_cacheable[id]) {  
      _cacheable[id] = true;  
      return null;
    }
    var map = _cache[id];
    if (map == null) {
      return null;
    }
    var data = map[_cursor];
    if (data == null) {
      return null;
    }
    _cursor = data[1];
    success = data[2];
    if (_cursor < _inputLen) {
      _ch = _input[_cursor];
    } else {
      _ch = -1;
    }
    return data;  
  }
  
  int _getState(List<List<int>> transitions) {
    var count = transitions.length;
    var state = 0;
    for ( ; state < count; state++) {
      var found = false;
      var ranges = transitions[state];    
      while (true) {
        var right = ranges.length ~/ 2;
        if (right == 0) {
          break;
        }
        var left = 0;
        if (right == 1) {
          if (_ch <= ranges[1] && _ch >= ranges[0]) {
            found = true;          
          }
          break;
        }
        int middle;
        while (left < right) {
          middle = (left + right) >> 1;
          var index = middle << 1;
          if (ranges[index + 1] < _ch) {
            left = middle + 1;
          } else {
            if (_ch >= ranges[index]) {
              found = true;
              break;
            }
            right = middle;
          }
        }
        break;
      }
      if (found) {
        return state; 
      }   
    }
    if (_ch != -1) {
      return state;
    }
    return state + 1;  
  }
  
  List _list(Object first, List next) {
    var length = next.length;
    var list = new List(length + 1);
    list[0] = first;
    for (var i = 0; i < length; i++) {
      list[i + 1] = next[i][1];
    }
    return list;
  }
  
  String _matchAny() {
    success = _cursor < _inputLen;
    if (success) {
      String result;
      if (_ch < 128) {
        result = _ascii[_ch];  
      } else {
        result = new String.fromCharCode(_ch);
      }    
      if (++_cursor < _inputLen) {
        _ch = _input[_cursor];
      } else {
        _ch = -1;
      }    
      return result;
    }    
    return null;  
  }
  
  String _matchChar(int ch, String string) {
    success = _ch == ch;
    if (success) {
      var result = string;  
      if (++_cursor < _inputLen) {
        _ch = _input[_cursor];
      } else {
        _ch = -1;
      }    
      return result;
    }  
    return null;  
  }
  
  String _matchMapping(int start, int end, List<bool> mapping) {
    success = _ch >= start && _ch <= end;
    if (success) {    
      if(mapping[_ch - start]) {
        String result;
        if (_ch < 128) {
          result = _ascii[_ch];  
        } else {
          result = new String.fromCharCode(_ch);
        }     
        if (++_cursor < _inputLen) {
          _ch = _input[_cursor];
        } else {
          _ch = -1;
        }      
        return result;
      }
      success = false;
    }  
    return null;  
  }
  
  String _matchRange(int start, int end) {
    success = _ch >= start && _ch <= end;
    if (success) {
      String result;
      if (_ch < 128) {
        result = _ascii[_ch];  
      } else {
        result = new String.fromCharCode(_ch);
      }        
      if (++_cursor < _inputLen) {
        _ch = _input[_cursor];
      } else {
        _ch = -1;
      }  
      return result;
    }  
    return null;  
  }
  
  String _matchRanges(List<int> ranges) {
    var length = ranges.length;
    for (var i = 0; i < length; i += 2) {    
      if (_ch >= ranges[i]) {
        if (_ch <= ranges[i + 1]) {
          String result;
          if (_ch < 128) {
            result = _ascii[_ch];  
          } else {
            result = new String.fromCharCode(_ch);
          }          
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
             _ch = -1;
          }
          success = true;    
          return result;
        }      
      } else break;  
    }
    success = false;  
    return null;  
  }
  
  String _matchString(List<int> codePoints, String string) {
    var length = codePoints.length;  
    success = _cursor + length <= _inputLen;
    if (success) {
      for (var i = 0; i < length; i++) {
        if (codePoints[i] != _input[_cursor + i]) {
          success = false;
          break;
        }
      }
    } else {
      success = false;
    }  
    if (success) {
      _cursor += length;      
      if (_cursor < _inputLen) {
        _ch = _input[_cursor];
      } else {
        _ch = -1;
      }    
      return string;      
    }  
    return null; 
  }
  
  void _nextChar() {
    if (++_cursor < _inputLen) {
      _ch = _input[_cursor];
    } else {
      _ch = -1;
    }  
  }
  
  dynamic _parse_any_char_until_eol() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var ch1 = _ch, pos1 = _cursor, testing0 = _testing; 
          _testing = _inputLen + 1;
          $$ = _parse_new_line();
          _ch = ch1;
          _cursor = pos1; 
          _testing = testing0;
          $$ = null;
          success = !success;
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _matchAny();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $2;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_any_chars_until_eol() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var testing0 = _testing; 
        for (var reps = []; ; ) {
          _testing = _cursor;
          $$ = _parse_any_char_until_eol();
          if (success) {  
            reps.add($$);
          } else {
            success = true;
            _testing = testing0;
            $$ = reps;
            break; 
          }
        }
        if (success) {    
          final $1 = $$;
          final $start = startPos0;
          $$ = _text();
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = true;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect3);
    }
    return $$;
  }
  
  dynamic _parse_binary_exponent_part() {
    var $$;
    switch (_getState(_transitions5)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          switch (_getState(_transitions6)) {
            case 0:
              var startPos1 = _startPos;
              _startPos = _cursor;
              $$ = _matchChar(80, 'P');
              _startPos = startPos1;
              break;
            case 1:
              var startPos2 = _startPos;
              _startPos = _cursor;
              $$ = _matchChar(112, 'p');
              _startPos = startPos2;
              break;
            case 2:
            case 3:
              $$ = null;
              success = false;
              break;
          }
          if (!success && _cursor > _testing) {
            _failure(_expect19);
          }
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          switch (_getState(_transitions7)) {
            case 0:
            case 3:
              var startPos3 = _startPos;
              _startPos = _cursor;
              success = true;
              $$ = '';
              _startPos = startPos3;
              break;
            case 1:
              while (true) {
                var startPos4 = _startPos;
                _startPos = _cursor;
                $$ = _parse_sign();
                _startPos = startPos4;
                if (success) break;
                var startPos5 = _startPos;
                _startPos = _cursor;
                success = true;
                $$ = '';
                _startPos = startPos5;
                break;
              }
              break;
            case 2:
              $$ = null;
              success = false;
              break;
          }
          if (!success && _cursor > _testing) {
            _failure(const [null]);
          }
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_digit_sequence();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = _text();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect19);
    }
    return $$;
  }
  
  dynamic _parse_c_char() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var ch1 = _ch, pos1 = _cursor, testing0 = _testing; 
            _testing = _inputLen + 1;
            $$ = _matchMapping(10, 92, _mapping1);
            _ch = ch1;
            _cursor = pos1; 
            _testing = testing0;
            $$ = null;
            success = !success;
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchAny();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos0;
              $$ = $2.codeUnitAt(0);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_escape_sequence();
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_character_constant_base() {
    var $$;
    switch (_getState(_transitions8)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(39, '\'');
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_c_char();
          if (!success) break;
          seq[1] = $$;
          $$ = _matchChar(39, '\'');
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = new CharacterLiteral(position: $start, text: _text(), value: $2);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings10, 'L\'');
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_c_char();
          if (!success) break;
          seq[1] = $$;
          $$ = _matchChar(39, '\'');
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos1;
            $$ = new CharacterLiteral(position: $start, text: _text(), value: $2);
          }
          break;
        }
        if (!success) {
          _ch = ch1;
          _cursor = pos1;
        }
        _startPos = startPos1;
        break;
      case 2:
        $$ = null;
        success = false;
        break;
      case 3:
        while (true) {
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchChar(39, '\'');
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _parse_c_char();
            if (!success) break;
            seq[1] = $$;
            $$ = _matchChar(39, '\'');
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos2;
              $$ = new CharacterLiteral(position: $start, text: _text(), value: $2);
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          if (success) break;
          var ch3 = _ch, pos3 = _cursor, startPos3 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchString(_strings10, 'L\'');
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _parse_c_char();
            if (!success) break;
            seq[1] = $$;
            $$ = _matchChar(39, '\'');
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos3;
              $$ = new CharacterLiteral(position: $start, text: _text(), value: $2);
            }
            break;
          }
          if (!success) {
            _ch = ch3;
            _cursor = pos3;
          }
          _startPos = startPos3;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect20);
    }
    return $$;
  }
  
  dynamic _parse_constant_base() {
    var $$;
    switch (_getState(_transitions9)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_character_constant_base();
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        _startPos = _cursor;
        $$ = _parse_floating_constant_base();
        _startPos = startPos1;
        break;
      case 2:
        while (true) {
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _parse_floating_constant_base();
          _startPos = startPos2;
          if (success) break;
          var startPos3 = _startPos;
          _startPos = _cursor;
          $$ = _parse_integer_constant_base();
          _startPos = startPos3;
          break;
        }
        break;
      case 3:
        $$ = null;
        success = false;
        break;
      case 4:
        while (true) {
          var startPos4 = _startPos;
          _startPos = _cursor;
          $$ = _parse_floating_constant_base();
          _startPos = startPos4;
          if (success) break;
          var startPos5 = _startPos;
          _startPos = _cursor;
          $$ = _parse_integer_constant_base();
          _startPos = startPos5;
          if (success) break;
          var startPos6 = _startPos;
          _startPos = _cursor;
          $$ = _parse_character_constant_base();
          _startPos = startPos6;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_control_line() {
    var $$;
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        while (true) {
          var startPos0 = _startPos;
          _startPos = _cursor;
          $$ = _parse_define_directive();
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_undef_directive();
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _parse_error_directive();
          _startPos = startPos2;
          if (success) break;
          var startPos3 = _startPos;
          _startPos = _cursor;
          $$ = _parse_include_directive();
          _startPos = startPos3;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect7);
    }
    return $$;
  }
  
  dynamic _parse_decimal_constant() {
    var $$;
    switch (_ch >= 49 && _ch <= 57 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_nonzero_digit();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_decimal_constant1();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = int.parse(_text());
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_decimal_constant1() {
    var $$;
    switch (_getState(_transitions10)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        success = true;
        $$ = '';
        _startPos = startPos0;
        break;
      case 1:
      case 3:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_digit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_decimal_constant1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_decimal_floating_constant() {
    var $$;
    switch (_getState(_transitions11)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_decimal_floating_constant_base();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces2();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_decimal_floating_constant_base() {
    var $$;
    switch (_getState(_transitions12)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_fractional_constant();
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_exponent_part();
          success = true; 
          _testing = testing0;
          if (!success) break;
          seq[1] = $$;
          var testing1 = _testing;
          _testing = _cursor;
          $$ = _parse_floating_suffix();
          success = true; 
          _testing = testing1;
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = _floatLiteral(_text(), $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 3:
        while (true) {
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_fractional_constant();
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            var testing2 = _testing;
            _testing = _cursor;
            $$ = _parse_exponent_part();
            success = true; 
            _testing = testing2;
            if (!success) break;
            seq[1] = $$;
            var testing3 = _testing;
            _testing = _cursor;
            $$ = _parse_floating_suffix();
            success = true; 
            _testing = testing3;
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos1;
              $$ = _floatLiteral(_text(), $start);
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          if (success) break;
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_digit_sequence();
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _parse_exponent_part();
            if (!success) break;
            seq[1] = $$;
            var testing4 = _testing;
            _testing = _cursor;
            $$ = _parse_floating_suffix();
            success = true; 
            _testing = testing4;
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos2;
              $$ = _floatLiteral(_text(), $start);
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_define() {
    var $$;
    _token = 0;  
    _tokenStart = _cursor;  
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings1, '#define');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect8);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_define_directive() {
    var $$;
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_define();
          if (!success) break;
          var seq = new List(4)..[0] = $$;
          $$ = _parse_identifier();
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_replacement_list();
          if (!success) break;
          seq[2] = $$;
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_new_line();
          success = true; 
          _testing = testing0;
          if (!success) break;
          seq[3] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            final $start = startPos0;
            $$ = new DefineDirective(fragments: $3, identifier: $2, position: $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect8);
    }
    return $$;
  }
  
  dynamic _parse_digit() {
    var $$;
    switch (_ch >= 48 && _ch <= 57 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchRange(48, 57);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_digit_sequence() {
    var $$;
    switch (_ch >= 48 && _ch <= 57 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var testing0;
        for (var first = true, reps; ;) {  
          $$ = _parse_digit();  
          if (success) {
           if (first) {      
              first = false;
              reps = [$$];
              testing0 = _testing;                  
            } else {
              reps.add($$);
            }
            _testing = _cursor;   
          } else {
            success = !first;
            if (success) {      
              _testing = testing0;
              $$ = reps;      
            } else $$ = null;
            break;
          }  
        }
        if (success) {    
          final $1 = $$;
          final $start = startPos0;
          $$ = _text();
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_elif() {
    var $$;
    _token = 1;  
    _tokenStart = _cursor;  
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings2, '#elif');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect4);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_elif_group() {
    var $$;
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_elif();
          if (!success) break;
          var seq = new List(4)..[0] = $$;
          $$ = _parse_replacement_list();
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_new_line();
          if (!success) break;
          seq[2] = $$;
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_group();
          success = true; 
          _testing = testing0;
          if (!success) break;
          seq[3] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            final $start = startPos0;
            $$ = new IfDirective(body: $4, condition: $2, name: $1, position: $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect4);
    }
    return $$;
  }
  
  dynamic _parse_elif_groups() {
    var $$;
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var testing0;
        for (var first = true, reps; ;) {  
          $$ = _parse_elif_group();  
          if (success) {
           if (first) {      
              first = false;
              reps = [$$];
              testing0 = _testing;                  
            } else {
              reps.add($$);
            }
            _testing = _cursor;   
          } else {
            success = !first;
            if (success) {      
              _testing = testing0;
              $$ = reps;      
            } else $$ = null;
            break;
          }  
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect4);
    }
    return $$;
  }
  
  dynamic _parse_else() {
    var $$;
    _token = 2;  
    _tokenStart = _cursor;  
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings3, '#else');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect5);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_else_group() {
    var $$;
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_else();
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_new_line();
          if (!success) break;
          seq[1] = $$;
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_group();
          success = true; 
          _testing = testing0;
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = new ElseDirective(body: $3, position: $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect5);
    }
    return $$;
  }
  
  dynamic _parse_endif_line() {
    var $$;
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings0, '#endif');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_new_line();
          success = true; 
          _testing = testing0;
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = new EndifDirective(position: $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect6);
    }
    return $$;
  }
  
  dynamic _parse_eof() {
    var $$;
    _token = 3;  
    _tokenStart = _cursor;  
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var ch0 = _ch, pos0 = _cursor, testing0 = _testing; 
        _testing = _inputLen + 1;
        $$ = _matchAny();
        _ch = ch0;
        _cursor = pos0; 
        _testing = testing0;
        $$ = null;
        success = !success;
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_error() {
    var $$;
    _token = 4;  
    _tokenStart = _cursor;  
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings4, '#error');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect10);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_error_directive() {
    var $$;
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_error();
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_any_chars_until_eol();
          if (!success) break;
          seq[1] = $$;
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_new_line();
          success = true; 
          _testing = testing0;
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = new ErrorDirective(message: $2, position: $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect10);
    }
    return $$;
  }
  
  dynamic _parse_escape_sequence() {
    var $$;
    switch (_ch == 92 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        while (true) {
          var startPos0 = _startPos;
          _startPos = _cursor;
          $$ = _parse_simple_escape_sequence();
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_octal_escape_sequence();
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _parse_hexadecimal_escape_sequence();
          _startPos = startPos2;
          if (success) break;
          var startPos3 = _startPos;
          _startPos = _cursor;
          $$ = _parse_universal_character_name();
          _startPos = startPos3;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
      case 2:
        var startPos4 = _startPos;
        _startPos = _cursor;
        $$ = _parse_hexadecimal_escape_sequence();
        _startPos = startPos4;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_exponent_part() {
    var $$;
    switch (_getState(_transitions13)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          switch (_getState(_transitions14)) {
            case 0:
              var startPos1 = _startPos;
              _startPos = _cursor;
              $$ = _matchChar(69, 'E');
              _startPos = startPos1;
              break;
            case 1:
              var startPos2 = _startPos;
              _startPos = _cursor;
              $$ = _matchChar(101, 'e');
              _startPos = startPos2;
              break;
            case 2:
            case 3:
              $$ = null;
              success = false;
              break;
          }
          if (!success && _cursor > _testing) {
            _failure(_expect21);
          }
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          switch (_getState(_transitions7)) {
            case 0:
            case 3:
              var startPos3 = _startPos;
              _startPos = _cursor;
              success = true;
              $$ = '';
              _startPos = startPos3;
              break;
            case 1:
              while (true) {
                var startPos4 = _startPos;
                _startPos = _cursor;
                $$ = _parse_sign();
                _startPos = startPos4;
                if (success) break;
                var startPos5 = _startPos;
                _startPos = _cursor;
                success = true;
                $$ = '';
                _startPos = startPos5;
                break;
              }
              break;
            case 2:
              $$ = null;
              success = false;
              break;
          }
          if (!success && _cursor > _testing) {
            _failure(const [null]);
          }
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_digit_sequence();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = _text();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect21);
    }
    return $$;
  }
  
  dynamic _parse_file_name() {
    var $$;
    switch (_getState(_transitions15)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var testing0;
        for (var first = true, reps; ;) {  
          $$ = _matchMapping(46, 122, _mapping2);  
          if (success) {
           if (first) {      
              first = false;
              reps = [$$];
              testing0 = _testing;                  
            } else {
              reps.add($$);
            }
            _testing = _cursor;   
          } else {
            success = !first;
            if (success) {      
              _testing = testing0;
              $$ = reps;      
            } else $$ = null;
            break;
          }  
        }
        if (success) {    
          final $1 = $$;
          final $start = startPos0;
          $$ = _text();
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_floating_constant_base() {
    var $$;
    switch (_getState(_transitions12)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_decimal_floating_constant();
        _startPos = startPos0;
        break;
      case 1:
      case 3:
        while (true) {
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_decimal_floating_constant();
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _parse_hexadecimal_floating_constant();
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_floating_suffix() {
    var $$;
    switch (_getState(_transitions16)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(70, 108, _mapping3);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_fractional_constant() {
    var $$;
    switch (_getState(_transitions12)) {
      case 0:
      case 3:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_digit_sequence();
          success = true; 
          _testing = testing0;
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _matchChar(46, '.');
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_digit_sequence();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = _text();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        while (true) {
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var testing1 = _testing;
            _testing = _cursor;
            $$ = _parse_digit_sequence();
            success = true; 
            _testing = testing1;
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _matchChar(46, '.');
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_digit_sequence();
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos1;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          if (success) break;
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_digit_sequence();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchChar(46, '.');
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos2;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_group() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[1] >= pos) {
      $$ = _getFromCache(1);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[1] = pos;
    }  
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var testing0;
        for (var first = true, reps; ;) {  
          $$ = _parse_group_part();  
          if (success) {
           if (first) {      
              first = false;
              reps = [$$];
              testing0 = _testing;                  
            } else {
              reps.add($$);
            }
            _testing = _cursor;   
          } else {
            success = !first;
            if (success) {      
              _testing = testing0;
              $$ = reps;      
            } else $$ = null;
            break;
          }  
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect1);
    }
    if (_cacheable[1]) {
      _addToCache($$, pos, 1);
    }    
    return $$;
  }
  
  dynamic _parse_group_part() {
    var $$;
    switch (_getState(_transitions0)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_text_line();
        _startPos = startPos0;
        break;
      case 1:
      case 3:
        while (true) {
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_if_section();
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _parse_control_line();
          _startPos = startPos2;
          if (success) break;
          var startPos3 = _startPos;
          _startPos = _cursor;
          $$ = _parse_text_line();
          _startPos = startPos3;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect1);
    }
    return $$;
  }
  
  dynamic _parse_header() {
    var $$;
    switch (_ch == 60 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_header_name();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect22);
    }
    return $$;
  }
  
  dynamic _parse_header_name() {
    var $$;
    switch (_ch == 60 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(60, '<');
          if (!success) break;
          var seq = new List(4)..[0] = $$;
          $$ = _parse_file_name();
          if (!success) break;
          seq[1] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_ch == 47 ? 0 : _ch == -1 ? 2 : 1) {
              case 0:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  $$ = _matchChar(47, '/');
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_file_name();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
              case 2:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect23);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[2] = $$;
          $$ = _matchChar(62, '>');
          if (!success) break;
          seq[3] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            final $start = startPos0;
            $$ = _text();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect22);
    }
    return $$;
  }
  
  dynamic _parse_hex_quad() {
    var $$;
    switch (_getState(_transitions17)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_hexadecimal_digit();
          if (!success) break;
          var seq = new List(4)..[0] = $$;
          $$ = _parse_hexadecimal_digit();
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_hexadecimal_digit();
          if (!success) break;
          seq[2] = $$;
          $$ = _parse_hexadecimal_digit();
          if (!success) break;
          seq[3] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            final $start = startPos0;
            $$ = _text();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_constant() {
    var $$;
    switch (_ch == 48 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_hexadecimal_prefix();
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_hexadecimal_digit();
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_hexadecimal_constant1();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = int.parse(_text(2), radix: 16);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect24);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_constant1() {
    var $$;
    switch (_getState(_transitions18)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        success = true;
        $$ = '';
        _startPos = startPos0;
        break;
      case 1:
      case 3:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_digit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_hexadecimal_constant1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_digit() {
    var $$;
    switch (_getState(_transitions17)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(48, 102, _mapping4);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_digit_sequence() {
    var $$;
    switch (_getState(_transitions17)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var testing0;
        for (var first = true, reps; ;) {  
          $$ = _parse_hexadecimal_digit();  
          if (success) {
           if (first) {      
              first = false;
              reps = [$$];
              testing0 = _testing;                  
            } else {
              reps.add($$);
            }
            _testing = _cursor;   
          } else {
            success = !first;
            if (success) {      
              _testing = testing0;
              $$ = reps;      
            } else $$ = null;
            break;
          }  
        }
        if (success) {    
          final $1 = $$;
          final $start = startPos0;
          $$ = _text();
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_escape_sequence() {
    var $$;
    switch (_ch == 92 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings11, '\\x');
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_hexadecimal_digit();
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_hexadecimal_escape_sequence1();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = int.parse(_text(2), radix: 16);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect25);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_escape_sequence1() {
    var $$;
    switch (_getState(_transitions18)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        success = true;
        $$ = '';
        _startPos = startPos0;
        break;
      case 1:
      case 3:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_digit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_hexadecimal_escape_sequence1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos1;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_floating_constant() {
    var $$;
    switch (_ch == 48 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_prefix();
            if (!success) break;
            var seq = new List(4)..[0] = $$;
            $$ = _parse_hexadecimal_fractional_constant();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_binary_exponent_part();
            if (!success) break;
            seq[2] = $$;
            var testing0 = _testing;
            _testing = _cursor;
            $$ = _parse_floating_suffix();
            success = true; 
            _testing = testing0;
            if (!success) break;
            seq[3] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $4 = seq[3];
              final $start = startPos0;
              $$ = _floatLiteral(_text(), $start);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_prefix();
            if (!success) break;
            var seq = new List(4)..[0] = $$;
            $$ = _parse_hexadecimal_digit_sequence();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_binary_exponent_part();
            if (!success) break;
            seq[2] = $$;
            var testing1 = _testing;
            _testing = _cursor;
            $$ = _parse_floating_suffix();
            success = true; 
            _testing = testing1;
            if (!success) break;
            seq[3] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $4 = seq[3];
              final $start = startPos1;
              $$ = _floatLiteral(_text(), $start);
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect24);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_fractional_constant() {
    var $$;
    switch (_getState(_transitions19)) {
      case 0:
      case 3:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_hexadecimal_digit_sequence();
          success = true; 
          _testing = testing0;
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _matchChar(46, '.');
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_hexadecimal_digit_sequence();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        while (true) {
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var testing1 = _testing;
            _testing = _cursor;
            $$ = _parse_hexadecimal_digit_sequence();
            success = true; 
            _testing = testing1;
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _matchChar(46, '.');
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_hexadecimal_digit_sequence();
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          if (success) break;
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_digit_sequence();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchChar(46, '.');
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_prefix() {
    var $$;
    switch (_ch == 48 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        while (true) {
          var startPos0 = _startPos;
          _startPos = _cursor;
          $$ = _matchString(_strings12, '0x');
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _matchString(_strings13, '0X');
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect24);
    }
    return $$;
  }
  
  dynamic _parse_identifier() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[24] >= pos) {
      $$ = _getFromCache(24);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[24] = pos;
    }  
    _token = 5;    
    _tokenStart = _cursor;    
    switch (_getState(_transitions2)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_identifier_base();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces2();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect13);
    }
    if (_cacheable[24]) {
      _addToCache($$, pos, 24);
    }    
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_identifier_base() {
    var $$;
    switch (_getState(_transitions2)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_identifier_nondigit();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_identifier_base1();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = new Identifier(name: _text(), position: $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_identifier_base1() {
    var $$;
    switch (_getState(_transitions20)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        success = true;
        $$ = '';
        _startPos = startPos0;
        break;
      case 1:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_digit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_identifier_base1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos1;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        while (true) {
          var ch1 = _ch, pos1 = _cursor, startPos3 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_identifier_nondigit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_identifier_base1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos3;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos3;
          if (success) break;
          var startPos4 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos4;
          break;
        }
        break;
      case 3:
        $$ = null;
        success = false;
        break;
      case 4:
        while (true) {
          var ch2 = _ch, pos2 = _cursor, startPos5 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_identifier_nondigit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_identifier_base1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos5;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos5;
          if (success) break;
          var ch3 = _ch, pos3 = _cursor, startPos6 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_digit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_identifier_base1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos6;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch3;
            _cursor = pos3;
          }
          _startPos = startPos6;
          if (success) break;
          var startPos7 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos7;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_identifier_nondigit() {
    var $$;
    switch (_getState(_transitions21)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_nondigit();
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        _startPos = _cursor;
        $$ = _parse_universal_character_name();
        _startPos = startPos1;
        break;
      case 2:
      case 3:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_if() {
    var $$;
    _token = 6;  
    _tokenStart = _cursor;  
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings5, '#if');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect14);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_if_group() {
    var $$;
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_ifdef();
            if (!success) break;
            var seq = new List(4)..[0] = $$;
            $$ = _parse_identifier();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_new_line();
            if (!success) break;
            seq[2] = $$;
            var testing0 = _testing;
            _testing = _cursor;
            $$ = _parse_group();
            success = true; 
            _testing = testing0;
            if (!success) break;
            seq[3] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $4 = seq[3];
              final $start = startPos0;
              $$ = new IfDirective(body: $4, condition: [_identToFragment($2)], name: $1, position: $start);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_ifndef();
            if (!success) break;
            var seq = new List(4)..[0] = $$;
            $$ = _parse_identifier();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_new_line();
            if (!success) break;
            seq[2] = $$;
            var testing1 = _testing;
            _testing = _cursor;
            $$ = _parse_group();
            success = true; 
            _testing = testing1;
            if (!success) break;
            seq[3] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $4 = seq[3];
              final $start = startPos1;
              $$ = new IfDirective(body: $4, condition: [_identToFragment($2)], name: $1, position: $start);
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          if (success) break;
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_if();
            if (!success) break;
            var seq = new List(4)..[0] = $$;
            $$ = _parse_replacement_list();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_new_line();
            if (!success) break;
            seq[2] = $$;
            var testing2 = _testing;
            _testing = _cursor;
            $$ = _parse_group();
            success = true; 
            _testing = testing2;
            if (!success) break;
            seq[3] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $4 = seq[3];
              final $start = startPos2;
              $$ = new IfDirective(body: $4, condition: $2, name: $1, position: $start);
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect2);
    }
    return $$;
  }
  
  dynamic _parse_if_section() {
    var $$;
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_if_group();
          if (!success) break;
          var seq = new List(4)..[0] = $$;
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_elif_groups();
          success = true; 
          _testing = testing0;
          if (!success) break;
          seq[1] = $$;
          var testing1 = _testing;
          _testing = _cursor;
          $$ = _parse_else_group();
          success = true; 
          _testing = testing1;
          if (!success) break;
          seq[2] = $$;
          $$ = _parse_endif_line();
          if (!success) break;
          seq[3] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            final $start = startPos0;
            $$ = new IfSection(ifGroup: $1, elifGroups: $2, elseGroup: $3, endifLine: $4, position: $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect2);
    }
    return $$;
  }
  
  dynamic _parse_ifdef() {
    var $$;
    _token = 7;  
    _tokenStart = _cursor;  
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings6, '#ifdef');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect15);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_ifndef() {
    var $$;
    _token = 8;  
    _tokenStart = _cursor;  
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings7, '#ifndef');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect16);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_include() {
    var $$;
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings14, '#include');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect26);
    }
    return $$;
  }
  
  dynamic _parse_include_directive() {
    var $$;
    _token = 9;  
    _tokenStart = _cursor;  
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_include();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_header();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = new IncludeDirective(header: $2, name: $1, position: $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect17);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_integer_constant_base() {
    var $$;
    switch (_getState(_transitions22)) {
      case 0:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_constant();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing0 = _testing;
            _testing = _cursor;
            $$ = _parse_integer_suffix();
            success = true; 
            _testing = testing0;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos0;
              $$ = new IntegerLiteral(position: $start, text: _text(), value: $1);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_octal_constant();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing1 = _testing;
            _testing = _cursor;
            $$ = _parse_integer_suffix();
            success = true; 
            _testing = testing1;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos1;
              $$ = new IntegerLiteral(position: $start, text: _text(), value: $1);
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_decimal_constant();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing2 = _testing;
          _testing = _cursor;
          $$ = _parse_integer_suffix();
          success = true; 
          _testing = testing2;
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos2;
            $$ = new IntegerLiteral(position: $start, text: _text(), value: $1);
          }
          break;
        }
        if (!success) {
          _ch = ch2;
          _cursor = pos2;
        }
        _startPos = startPos2;
        break;
      case 2:
        $$ = null;
        success = false;
        break;
      case 3:
        while (true) {
          var ch3 = _ch, pos3 = _cursor, startPos3 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_decimal_constant();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing3 = _testing;
            _testing = _cursor;
            $$ = _parse_integer_suffix();
            success = true; 
            _testing = testing3;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos3;
              $$ = new IntegerLiteral(position: $start, text: _text(), value: $1);
            }
            break;
          }
          if (!success) {
            _ch = ch3;
            _cursor = pos3;
          }
          _startPos = startPos3;
          if (success) break;
          var ch4 = _ch, pos4 = _cursor, startPos4 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_constant();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing4 = _testing;
            _testing = _cursor;
            $$ = _parse_integer_suffix();
            success = true; 
            _testing = testing4;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos4;
              $$ = new IntegerLiteral(position: $start, text: _text(), value: $1);
            }
            break;
          }
          if (!success) {
            _ch = ch4;
            _cursor = pos4;
          }
          _startPos = startPos4;
          if (success) break;
          var ch5 = _ch, pos5 = _cursor, startPos5 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_octal_constant();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing5 = _testing;
            _testing = _cursor;
            $$ = _parse_integer_suffix();
            success = true; 
            _testing = testing5;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos5;
              $$ = new IntegerLiteral(position: $start, text: _text(), value: $1);
            }
            break;
          }
          if (!success) {
            _ch = ch5;
            _cursor = pos5;
          }
          _startPos = startPos5;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_integer_suffix() {
    var $$;
    switch (_getState(_transitions23)) {
      case 0:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_long_long_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing0 = _testing;
            _testing = _cursor;
            $$ = _parse_unsigned_suffix();
            success = true; 
            _testing = testing0;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_long_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing1 = _testing;
            _testing = _cursor;
            $$ = _parse_unsigned_suffix();
            success = true; 
            _testing = testing1;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        while (true) {
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_unsigned_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_long_long_suffix();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          if (success) break;
          var ch3 = _ch, pos3 = _cursor, startPos3 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_unsigned_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing2 = _testing;
            _testing = _cursor;
            $$ = _parse_long_suffix();
            success = true; 
            _testing = testing2;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch3;
            _cursor = pos3;
          }
          _startPos = startPos3;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
      case 3:
        while (true) {
          var ch4 = _ch, pos4 = _cursor, startPos4 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_unsigned_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing3 = _testing;
            _testing = _cursor;
            $$ = _parse_long_suffix();
            success = true; 
            _testing = testing3;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch4;
            _cursor = pos4;
          }
          _startPos = startPos4;
          if (success) break;
          var ch5 = _ch, pos5 = _cursor, startPos5 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_long_long_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing4 = _testing;
            _testing = _cursor;
            $$ = _parse_unsigned_suffix();
            success = true; 
            _testing = testing4;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch5;
            _cursor = pos5;
          }
          _startPos = startPos5;
          if (success) break;
          var ch6 = _ch, pos6 = _cursor, startPos6 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_long_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing5 = _testing;
            _testing = _cursor;
            $$ = _parse_unsigned_suffix();
            success = true; 
            _testing = testing5;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch6;
            _cursor = pos6;
          }
          _startPos = startPos6;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_long_long_suffix() {
    var $$;
    switch (_getState(_transitions24)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchString(_strings15, 'LL');
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        _startPos = _cursor;
        $$ = _matchString(_strings16, 'll');
        _startPos = startPos1;
        break;
      case 2:
      case 3:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect27);
    }
    return $$;
  }
  
  dynamic _parse_long_suffix() {
    var $$;
    switch (_getState(_transitions25)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(76, 108, _mapping5);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_new_line() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[29] >= pos) {
      $$ = _getFromCache(29);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[29] = pos;
    }  
    _token = 10;    
    _tokenStart = _cursor;    
    switch (_getState(_transitions3)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(10, 13, _mapping0);
        _startPos = startPos0;
        break;
      case 1:
        while (true) {
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _matchString(_strings8, '\r\n');
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _matchMapping(10, 13, _mapping0);
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
      case 3:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect12);
    }
    if (_cacheable[29]) {
      _addToCache($$, pos, 29);
    }    
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_new_line_fragment() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[18] >= pos) {
      $$ = _getFromCache(18);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[18] = pos;
    }  
    switch (_getState(_transitions1)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_new_line();
        if (success) {    
          final $1 = $$;
          final $start = startPos0;
          $$ = new SourceFragment(position: $start, text: _text(), value: _text());
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect12);
    }
    if (_cacheable[18]) {
      _addToCache($$, pos, 18);
    }    
    return $$;
  }
  
  dynamic _parse_nondigit() {
    var $$;
    switch (_getState(_transitions26)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(65, 122, _mapping6);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_nonzero_digit() {
    var $$;
    switch (_ch >= 49 && _ch <= 57 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchRange(49, 57);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_octal_constant() {
    var $$;
    switch (_ch == 48 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(48, '0');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_octal_constant1();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = int.parse(_text(), radix: 8);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect28);
    }
    return $$;
  }
  
  dynamic _parse_octal_constant1() {
    var $$;
    switch (_getState(_transitions27)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        success = true;
        $$ = '';
        _startPos = startPos0;
        break;
      case 1:
      case 3:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_octal_digit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_octal_constant1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_octal_digit() {
    var $$;
    switch (_ch >= 48 && _ch <= 55 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchRange(48, 55);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_octal_escape_sequence() {
    var $$;
    switch (_ch == 92 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchChar(92, '\\');
            if (!success) break;
            var seq = new List(4)..[0] = $$;
            $$ = _parse_octal_digit();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_octal_digit();
            if (!success) break;
            seq[2] = $$;
            $$ = _parse_octal_digit();
            if (!success) break;
            seq[3] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $4 = seq[3];
              final $start = startPos0;
              $$ = int.parse(_text(1), radix: 8);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchChar(92, '\\');
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _parse_octal_digit();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_octal_digit();
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos1;
              $$ = int.parse(_text(1), radix: 8);
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          if (success) break;
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchChar(92, '\\');
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_octal_digit();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos2;
              $$ = int.parse($2, radix: 8);
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          break;
        }
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect29);
    }
    return $$;
  }
  
  dynamic _parse_replacement_list() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var testing0 = _testing; 
        for (var reps = []; ; ) {
          _testing = _cursor;
          $$ = _parse_source_fragment();
          if (success) {  
            reps.add($$);
          } else {
            success = true;
            _testing = testing0;
            $$ = reps;
            break; 
          }
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = true;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect3);
    }
    return $$;
  }
  
  dynamic _parse_s_char() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var ch1 = _ch, pos1 = _cursor, testing0 = _testing; 
            _testing = _inputLen + 1;
            $$ = _matchMapping(10, 92, _mapping7);
            _ch = ch1;
            _cursor = pos1; 
            _testing = testing0;
            $$ = null;
            success = !success;
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchAny();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos0;
              $$ = $2.codeUnitAt(0);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_escape_sequence();
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_s_char_sequence() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var testing0;
        for (var first = true, reps; ;) {  
          $$ = _parse_s_char();  
          if (success) {
           if (first) {      
              first = false;
              reps = [$$];
              testing0 = _testing;                  
            } else {
              reps.add($$);
            }
            _testing = _cursor;   
          } else {
            success = !first;
            if (success) {      
              _testing = testing0;
              $$ = reps;      
            } else $$ = null;
            break;
          }  
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_sign() {
    var $$;
    switch (_getState(_transitions28)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(43, 45, _mapping8);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_simple_escape_sequence() {
    var $$;
    switch (_ch == 92 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(92, '\\');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _matchMapping(34, 118, _mapping9);
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = _escape($1);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_source_fragment() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[30] >= pos) {
      $$ = _getFromCache(30);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[30] = pos;
    }  
    _token = 11;    
    _tokenStart = _cursor;    
    switch (_getState(_transitions4)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var ch1 = _ch, pos1 = _cursor, testing0 = _testing; 
          _testing = _inputLen + 1;
          switch (_getState(_transitions3)) {
            case 0:
              var startPos1 = _startPos;
              _startPos = _cursor;
              $$ = _matchMapping(10, 13, _mapping0);
              _startPos = startPos1;
              break;
            case 1:
              while (true) {
                var startPos2 = _startPos;
                _startPos = _cursor;
                $$ = _matchString(_strings8, '\r\n');
                _startPos = startPos2;
                if (success) break;
                var startPos3 = _startPos;
                _startPos = _cursor;
                $$ = _matchMapping(10, 13, _mapping0);
                _startPos = startPos3;
                break;
              }
              break;
            case 2:
            case 3:
              $$ = null;
              success = false;
              break;
          }
          if (!success && _cursor > _testing) {
            _failure(const [null]);
          }
          _ch = ch1;
          _cursor = pos1; 
          _testing = testing0;
          $$ = null;
          success = !success;
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _matchAny();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = new SourceFragment(position: $start, text: _text(), value: _text());
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        while (true) {
          var startPos4 = _startPos;
          _startPos = _cursor;
          $$ = _parse_string_literal_base();
          if (success) {    
            final $1 = $$;
            final $start = startPos4;
            $$ = new SourceFragment(position: $start, text: _text(), value: $1.value);
          }
          _startPos = startPos4;
          if (success) break;
          var ch2 = _ch, pos2 = _cursor, startPos5 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var ch3 = _ch, pos3 = _cursor, testing1 = _testing; 
            _testing = _inputLen + 1;
            switch (_getState(_transitions3)) {
              case 0:
                var startPos6 = _startPos;
                _startPos = _cursor;
                $$ = _matchMapping(10, 13, _mapping0);
                _startPos = startPos6;
                break;
              case 1:
                while (true) {
                  var startPos7 = _startPos;
                  _startPos = _cursor;
                  $$ = _matchString(_strings8, '\r\n');
                  _startPos = startPos7;
                  if (success) break;
                  var startPos8 = _startPos;
                  _startPos = _cursor;
                  $$ = _matchMapping(10, 13, _mapping0);
                  _startPos = startPos8;
                  break;
                }
                break;
              case 2:
              case 3:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(const [null]);
            }
            _ch = ch3;
            _cursor = pos3; 
            _testing = testing1;
            $$ = null;
            success = !success;
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchAny();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos5;
              $$ = new SourceFragment(position: $start, text: _text(), value: _text());
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos5;
          break;
        }
        break;
      case 2:
        while (true) {
          var startPos9 = _startPos;
          _startPos = _cursor;
          $$ = _parse_constant_base();
          if (success) {    
            final $1 = $$;
            final $start = startPos9;
            $$ = new SourceFragment(position: $start, text: _text(), value: $1.value);
          }
          _startPos = startPos9;
          if (success) break;
          var ch4 = _ch, pos4 = _cursor, startPos10 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var ch5 = _ch, pos5 = _cursor, testing2 = _testing; 
            _testing = _inputLen + 1;
            switch (_getState(_transitions3)) {
              case 0:
                var startPos11 = _startPos;
                _startPos = _cursor;
                $$ = _matchMapping(10, 13, _mapping0);
                _startPos = startPos11;
                break;
              case 1:
                while (true) {
                  var startPos12 = _startPos;
                  _startPos = _cursor;
                  $$ = _matchString(_strings8, '\r\n');
                  _startPos = startPos12;
                  if (success) break;
                  var startPos13 = _startPos;
                  _startPos = _cursor;
                  $$ = _matchMapping(10, 13, _mapping0);
                  _startPos = startPos13;
                  break;
                }
                break;
              case 2:
              case 3:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(const [null]);
            }
            _ch = ch5;
            _cursor = pos5; 
            _testing = testing2;
            $$ = null;
            success = !success;
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchAny();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos10;
              $$ = new SourceFragment(position: $start, text: _text(), value: _text());
            }
            break;
          }
          if (!success) {
            _ch = ch4;
            _cursor = pos4;
          }
          _startPos = startPos10;
          break;
        }
        break;
      case 3:
        while (true) {
          var startPos14 = _startPos;
          _startPos = _cursor;
          $$ = _parse_identifier_base();
          if (success) {    
            final $1 = $$;
            final $start = startPos14;
            $$ = new SourceFragment(position: $start, text: _text(), value: new Symbol($1.name));
          }
          _startPos = startPos14;
          if (success) break;
          var ch6 = _ch, pos6 = _cursor, startPos15 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var ch7 = _ch, pos7 = _cursor, testing3 = _testing; 
            _testing = _inputLen + 1;
            switch (_getState(_transitions3)) {
              case 0:
                var startPos16 = _startPos;
                _startPos = _cursor;
                $$ = _matchMapping(10, 13, _mapping0);
                _startPos = startPos16;
                break;
              case 1:
                while (true) {
                  var startPos17 = _startPos;
                  _startPos = _cursor;
                  $$ = _matchString(_strings8, '\r\n');
                  _startPos = startPos17;
                  if (success) break;
                  var startPos18 = _startPos;
                  _startPos = _cursor;
                  $$ = _matchMapping(10, 13, _mapping0);
                  _startPos = startPos18;
                  break;
                }
                break;
              case 2:
              case 3:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(const [null]);
            }
            _ch = ch7;
            _cursor = pos7; 
            _testing = testing3;
            $$ = null;
            success = !success;
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchAny();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos15;
              $$ = new SourceFragment(position: $start, text: _text(), value: _text());
            }
            break;
          }
          if (!success) {
            _ch = ch6;
            _cursor = pos6;
          }
          _startPos = startPos15;
          break;
        }
        break;
      case 4:
      case 6:
        while (true) {
          var startPos19 = _startPos;
          _startPos = _cursor;
          $$ = _parse_string_literal_base();
          if (success) {    
            final $1 = $$;
            final $start = startPos19;
            $$ = new SourceFragment(position: $start, text: _text(), value: $1.value);
          }
          _startPos = startPos19;
          if (success) break;
          var startPos20 = _startPos;
          _startPos = _cursor;
          $$ = _parse_constant_base();
          if (success) {    
            final $1 = $$;
            final $start = startPos20;
            $$ = new SourceFragment(position: $start, text: _text(), value: $1.value);
          }
          _startPos = startPos20;
          if (success) break;
          var startPos21 = _startPos;
          _startPos = _cursor;
          $$ = _parse_identifier_base();
          if (success) {    
            final $1 = $$;
            final $start = startPos21;
            $$ = new SourceFragment(position: $start, text: _text(), value: new Symbol($1.name));
          }
          _startPos = startPos21;
          if (success) break;
          var ch8 = _ch, pos8 = _cursor, startPos22 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var ch9 = _ch, pos9 = _cursor, testing4 = _testing; 
            _testing = _inputLen + 1;
            switch (_getState(_transitions3)) {
              case 0:
                var startPos23 = _startPos;
                _startPos = _cursor;
                $$ = _matchMapping(10, 13, _mapping0);
                _startPos = startPos23;
                break;
              case 1:
                while (true) {
                  var startPos24 = _startPos;
                  _startPos = _cursor;
                  $$ = _matchString(_strings8, '\r\n');
                  _startPos = startPos24;
                  if (success) break;
                  var startPos25 = _startPos;
                  _startPos = _cursor;
                  $$ = _matchMapping(10, 13, _mapping0);
                  _startPos = startPos25;
                  break;
                }
                break;
              case 2:
              case 3:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(const [null]);
            }
            _ch = ch9;
            _cursor = pos9; 
            _testing = testing4;
            $$ = null;
            success = !success;
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchAny();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos22;
              $$ = new SourceFragment(position: $start, text: _text(), value: _text());
            }
            break;
          }
          if (!success) {
            _ch = ch8;
            _cursor = pos8;
          }
          _startPos = startPos22;
          break;
        }
        break;
      case 5:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect18);
    }
    if (_cacheable[30]) {
      _addToCache($$, pos, 30);
    }    
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_source_line() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var testing0;
            for (var first = true, reps; ;) {  
              $$ = _parse_source_fragment();  
              if (success) {
               if (first) {      
                  first = false;
                  reps = [$$];
                  testing0 = _testing;                  
                } else {
                  reps.add($$);
                }
                _testing = _cursor;   
              } else {
                success = !first;
                if (success) {      
                  _testing = testing0;
                  $$ = reps;      
                } else $$ = null;
                break;
              }  
            }
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing1 = _testing;
            _testing = _cursor;
            $$ = _parse_new_line_fragment();
            success = true; 
            _testing = testing1;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos0;
              $$ = _sourceLine($1, $2, $start);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_new_line_fragment();
          if (success) {    
            final $1 = $$;
            final $start = startPos1;
            $$ = _sourceLine([$1], null, $start);
          }
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
      case 2:
        var ch1 = _ch, pos1 = _cursor, startPos2 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var testing2;
          for (var first = true, reps; ;) {  
            $$ = _parse_source_fragment();  
            if (success) {
             if (first) {      
                first = false;
                reps = [$$];
                testing2 = _testing;                  
              } else {
                reps.add($$);
              }
              _testing = _cursor;   
            } else {
              success = !first;
              if (success) {      
                _testing = testing2;
                $$ = reps;      
              } else $$ = null;
              break;
            }  
          }
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing3 = _testing;
          _testing = _cursor;
          $$ = _parse_new_line_fragment();
          success = true; 
          _testing = testing3;
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos2;
            $$ = _sourceLine($1, $2, $start);
          }
          break;
        }
        if (!success) {
          _ch = ch1;
          _cursor = pos1;
        }
        _startPos = startPos2;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect11);
    }
    return $$;
  }
  
  dynamic _parse_spaces() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var testing0 = _testing; 
        for (var reps = []; ; ) {
          _testing = _cursor;
          $$ = _matchMapping(9, 32, _mapping10);
          if (success) {  
            reps.add($$);
          } else {
            success = true;
            _testing = testing0;
            $$ = reps;
            break; 
          }
        }
        if (success) {    
          final $1 = $$;
          final $start = startPos0;
          $$ = _text();
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = true;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect3);
    }
    return $$;
  }
  
  dynamic _parse_spaces2() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_spaces();
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = true;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect3);
    }
    return $$;
  }
  
  dynamic _parse_string_literal_base() {
    var $$;
    switch (_getState(_transitions29)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(34, '\"');
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_s_char_sequence();
          success = true; 
          _testing = testing0;
          if (!success) break;
          seq[1] = $$;
          $$ = _matchChar(34, '\"');
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = _stringLiteral(_text(), $2, $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings17, 'L\"');
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          var testing1 = _testing;
          _testing = _cursor;
          $$ = _parse_s_char_sequence();
          success = true; 
          _testing = testing1;
          if (!success) break;
          seq[1] = $$;
          $$ = _matchChar(34, '\"');
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos1;
            $$ = _stringLiteral(_text(), $2, $start);
          }
          break;
        }
        if (!success) {
          _ch = ch1;
          _cursor = pos1;
        }
        _startPos = startPos1;
        break;
      case 2:
        $$ = null;
        success = false;
        break;
      case 3:
        while (true) {
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchChar(34, '\"');
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            var testing2 = _testing;
            _testing = _cursor;
            $$ = _parse_s_char_sequence();
            success = true; 
            _testing = testing2;
            if (!success) break;
            seq[1] = $$;
            $$ = _matchChar(34, '\"');
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos2;
              $$ = _stringLiteral(_text(), $2, $start);
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          if (success) break;
          var ch3 = _ch, pos3 = _cursor, startPos3 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchString(_strings17, 'L\"');
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            var testing3 = _testing;
            _testing = _cursor;
            $$ = _parse_s_char_sequence();
            success = true; 
            _testing = testing3;
            if (!success) break;
            seq[1] = $$;
            $$ = _matchChar(34, '\"');
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos3;
              $$ = _stringLiteral(_text(), $2, $start);
            }
            break;
          }
          if (!success) {
            _ch = ch3;
            _cursor = pos3;
          }
          _startPos = startPos3;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect30);
    }
    return $$;
  }
  
  dynamic _parse_text_line() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var ch1 = _ch, pos1 = _cursor, testing0 = _testing; 
          _testing = _inputLen + 1;
          $$ = _matchChar(35, '#');
          _ch = ch1;
          _cursor = pos1; 
          _testing = testing0;
          $$ = null;
          success = !success;
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_source_line();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $2;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect11);
    }
    return $$;
  }
  
  dynamic _parse_undef() {
    var $$;
    _token = 12;  
    _tokenStart = _cursor;  
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings9, '#undef');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect9);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_undef_directive() {
    var $$;
    switch (_ch == 35 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_undef();
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_identifier();
          if (!success) break;
          seq[1] = $$;
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_new_line();
          success = true; 
          _testing = testing0;
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = new UndefDirective(identifier: $2, position: $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect9);
    }
    return $$;
  }
  
  dynamic _parse_universal_character_name() {
    var $$;
    switch (_ch == 92 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchString(_strings18, '\\U');
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _parse_hex_quad();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_hex_quad();
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos0;
              $$ = int.parse(_text(2), radix: 16);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchString(_strings19, '\\u');
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_hex_quad();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos1;
              $$ = int.parse(_text(2), radix: 16);
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect31);
    }
    return $$;
  }
  
  dynamic _parse_unsigned_suffix() {
    var $$;
    switch (_getState(_transitions30)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(85, 117, _mapping11);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  String _text([int offset = 0]) {
    return new String.fromCharCodes(_input.sublist(_startPos + offset, _cursor));
  }
  
  int _toCodePoint(String string) {
    if (string == null) {
      throw new ArgumentError("string: $string");
    }
  
    var length = string.length;
    if (length == 0) {
      throw new StateError("An empty string contains no elements.");
    }
  
    var start = string.codeUnitAt(0);
    if (length == 1) {
      return start;
    }
  
    if ((start & 0xFC00) == 0xD800) {
      var end = string.codeUnitAt(1);
      if ((end & 0xFC00) == 0xDC00) {
        return (0x10000 + ((start & 0x3FF) << 10) + (end & 0x3FF));
      }
    }
  
    return start;
  }
  
  List<int> _toCodePoints(String string) {
    if (string == null) {
      throw new ArgumentError("string: $string");
    }
  
    var length = string.length;
    if (length == 0) {
      return const <int>[];
    }
  
    var codePoints = <int>[];
    codePoints.length = length;
    var i = 0;
    var pos = 0;
    for ( ; i < length; pos++) {
      var start = string.codeUnitAt(i);
      i++;
      if ((start & 0xFC00) == 0xD800 && i < length) {
        var end = string.codeUnitAt(i);
        if ((end & 0xFC00) == 0xDC00) {
          codePoints[pos] = (0x10000 + ((start & 0x3FF) << 10) + (end & 0x3FF));
          i++;
        } else {
          codePoints[pos] = start;
        }
      } else {
        codePoints[pos] = start;
      }
    }
  
    codePoints.length = pos;
    return codePoints;
  }
  
  static List<bool> _unmap(List<int> mapping) {
    var length = mapping.length;
    var result = new List<bool>(length * 31);
    var offset = 0;
    for (var i = 0; i < length; i++) {
      var v = mapping[i];
      for (var j = 0; j < 31; j++) {
        result[offset++] = v & (1 << j) == 0 ? false : true;
      }
    }
    return result;
  }
  
  List<MacroParserError> errors() {
    if (success) {
      return <MacroParserError>[];
    }
  
    String escape(int c) {
      switch (c) {
        case 10:
          return r"\n";
        case 13:
          return r"\r";
        case 09:
          return r"\t";
        case -1:
          return "";
      }
      return new String.fromCharCode(c);
    } 
    
    String getc(int position) {  
      if (position < _inputLen) {
        return "'${escape(_input[position])}'";      
      }       
      return "end of file";
    }
  
    var errors = <MacroParserError>[];
    if (_failurePos >= _cursor) {
      var set = new Set<MacroParserError>();
      set.addAll(_errors);
      for (var error in set) {
        if (error.position >= _failurePos) {
          errors.add(error);
        }
      }
      var names = new Set<String>();  
      names.addAll(_expected);
      if (names.contains(null)) {
        var string = getc(_failurePos);
        var message = "Unexpected $string";
        var error = new MacroParserError(MacroParserError.UNEXPECTED, _failurePos, _failurePos, message);
        errors.add(error);
      } else {      
        var found = getc(_failurePos);      
        var list = names.toList();
        list.sort();
        var message = "Expected ${list.join(", ")} but found $found";
        var error = new MacroParserError(MacroParserError.EXPECTED, _failurePos, _failurePos, message);
        errors.add(error);
      }        
    }
    errors.sort((a, b) => a.position.compareTo(b.position));
    return errors;  
  }
  
  dynamic parse_preprocessing_file() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_group();
          success = true; 
          _testing = testing0;
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_eof();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = new PreprocessingFile(groups: $1, position: $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    return $$;
  }
  
  void reset(int pos) {
    if (pos == null) {
      throw new ArgumentError('pos: $pos');
    }
    if (pos < 0 || pos > _inputLen) {
      throw new RangeError('pos');
    }      
    _cursor = pos;
    _cache = new List<Map<int, List>>(84);
    _cachePos = new List<int>.filled(84, -1);  
    _cacheable = new List<bool>.filled(84, false);
    _ch = -1;
    _errors = <MacroParserError>[];   
    _expected = <String>[];
    _failurePos = -1;
    _startPos = pos;        
    _testing = -1;
    _token = null;
    _tokenStart = null;  
    if (_cursor < _inputLen) {
      _ch = _input[_cursor];
    }
    success = true;    
  }
  
}

class MacroParserError {
  static const int EXPECTED = 1;    
      
  static const int MALFORMED = 2;    
      
  static const int MISSING = 3;    
      
  static const int UNEXPECTED = 4;    
      
  static const int UNTERMINATED = 5;    
      
  final int hashCode = 0;
  
  final String message;
  
  final int position;
  
  final int start;
  
  final int type;
  
  MacroParserError(this.type, this.position, this.start, this.message);
  
  bool operator ==(other) {
    if (identical(this, other)) return true;
    if (other is MacroParserError) {
      return type == other.type && position == other.position &&
      start == other.start && message == other.message;  
    }
    return false;
  }
  
}

