// This code was generated by a tool.
// Processing tool available at https://github.com/mezoni/peg

part of macro_processor.internal.parsers.expression_parser;

Expression _buildBinary(Expression first, List rest) {
  Expression builder(Expression result, List element) {
    return new BinaryExpression(left: result, operator: element[0], position: result.position, right: element[1]);
  };
  return _buildTree(first, rest, builder);
}

Expression _buildTree(Expression first, List rest, builder(Expression result, List rest)) {
  var result = first;
  for (var i = 0; i < rest.length; i++) {
    result = builder(result, rest[i]);
  }
  return result;
}

Expression _conditional(Expression condition, Expression success, Expression fail, int position) {
  return new ConditionalExpression(condition: condition, success: success, fail: fail, position: position);
}

int _escape(String ch) {
  switch(ch) {
    case "a":
      return 0x07;
    case "b":
      return 0x08;
    case "f":
      return 0x0c;
    case "n":
      return 0x0a;
    case "r":
      return 0x0d;
    case "t":
      return 0x09;
    case "v":
      return 0x0b;
    case "\'":
      return 0x27;
    case "\"":
      return 0x22;
    case "\?":
      return 0x3f;
    case "\\":
      return 0x5c;
    default:
      throw new StateError("Unknown escape sequence: \\$ch");
  }
}

FloatingPointLiteral _floatLiteral(String source, int position) {
  var value = _parserFloat(source);
  return new FloatingPointLiteral(position: position, text: source, value: value);
}

double _parserFloat(String source) {
  source = source.toLowerCase();
  var hex = false;
  if (source.startsWith("0x")) {
    source = source.substring(2);
    hex = true;
  }
  var length = source.length;
  var endsWith = source[length - 1];
  if (endsWith == "f" || endsWith == "l") {
    source = source.substring(0, length - 1);
  }
  if (!hex) {
    return double.parse(source);
  }
  var index = source.indexOf("p");
  var exponent = int.parse(source.substring(index + 1));
  source = source.substring(0, index);
  index = source.indexOf(".");
  int integer = 0;
  int fractional = 0;
  if (index == 0) {
    fractional = int.parse(source.substring(1), radix: 16);
  } else if (index > 0) {
    integer = int.parse(source.substring(0, index), radix: 16);
    fractional = int.parse(source.substring(index + 1), radix: 16);
  } else {
    integer = int.parse(source, radix: 16);
  }
  var d = double.parse(".$fractional") * .625;
  return (integer + d) * pow(2, exponent);
}

StringLiteral _stringLiteral(String source, List<int> characters, int position) {
  var value = "";
  if (characters != null) {
    value = new String.fromCharCodes(characters);
  }
  return new StringLiteral(position: position, text: source, value: value);
}

SourceLine _sourceLine(List<SourceFragment> fragments, SourceFragment last, int position) {
  if (last != null) {
    fragments.add(last);
  }
  return new SourceLine(fragments: fragments, position: position);
}

Expression _unary(String operator, Expression operand, int position) {
  return new UnaryExpression(operand: operand, operator: operator, position: position);
}

class ExprParser {
  static final List<String> _ascii = new List<String>.generate(128, (c) => new String.fromCharCode(c));
  
  static final List<String> _expect0 = <String>["\'(\'", "\'defined\'", "constant", "identifier", "string_literal", "unary_operator"];
  
  static final List<String> _expect1 = <String>["eof", "new_line"];
  
  static final List<String> _expect10 = <String>["additive_operator"];
  
  static final List<String> _expect11 = <String>["multiplicative_operator"];
  
  static final List<String> _expect12 = <String>["\'(\'", "\'defined\'", "constant", "identifier", "string_literal"];
  
  static final List<String> _expect13 = <String>["\'defined\'"];
  
  static final List<String> _expect14 = <String>["constant"];
  
  static final List<String> _expect15 = <String>["eof"];
  
  static final List<String> _expect16 = <String>["identifier"];
  
  static final List<String> _expect17 = <String>["\'(\'"];
  
  static final List<String> _expect18 = <String>["new_line"];
  
  static final List<String> _expect19 = <String>["\'?\'"];
  
  static final List<String> _expect2 = <String>["\'||\'"];
  
  static final List<String> _expect20 = <String>["\')\'"];
  
  static final List<String> _expect21 = <String>["\':\'"];
  
  static final List<String> _expect22 = <String>["string_literal"];
  
  static final List<String> _expect23 = <String>["unary_operator"];
  
  static final List<String> _expect24 = <String>["*"];
  
  static final List<String> _expect25 = <String>["P", "p"];
  
  static final List<String> _expect26 = <String>["\'", "L\'"];
  
  static final List<String> _expect27 = <String>["=="];
  
  static final List<String> _expect28 = <String>["!"];
  
  static final List<String> _expect29 = <String>["E", "e"];
  
  static final List<String> _expect3 = <String>["\'&&\'"];
  
  static final List<String> _expect30 = <String>[">"];
  
  static final List<String> _expect31 = <String>[">="];
  
  static final List<String> _expect32 = <String>["0X", "0x"];
  
  static final List<String> _expect33 = <String>["\\x"];
  
  static final List<String> _expect34 = <String>["LL", "ll"];
  
  static final List<String> _expect35 = <String>["<<"];
  
  static final List<String> _expect36 = <String>["<"];
  
  static final List<String> _expect37 = <String>["<="];
  
  static final List<String> _expect38 = <String>["-"];
  
  static final List<String> _expect39 = <String>["!="];
  
  static final List<String> _expect4 = <String>["\'|\'"];
  
  static final List<String> _expect40 = <String>["0"];
  
  static final List<String> _expect41 = <String>["\\"];
  
  static final List<String> _expect42 = <String>["%"];
  
  static final List<String> _expect43 = <String>["+"];
  
  static final List<String> _expect44 = <String>["/"];
  
  static final List<String> _expect45 = <String>[];
  
  static final List<String> _expect46 = <String>["\"", "L\""];
  
  static final List<String> _expect47 = <String>["~"];
  
  static final List<String> _expect48 = <String>["\\U", "\\u"];
  
  static final List<String> _expect5 = <String>["\'^\'"];
  
  static final List<String> _expect6 = <String>["\'&\'"];
  
  static final List<String> _expect7 = <String>["equality_operator"];
  
  static final List<String> _expect8 = <String>["relational_operator"];
  
  static final List<String> _expect9 = <String>["\'<<\'"];
  
  static final List<bool> _lookahead = _unmap([0x1401, 0x0, 0x0, 0x3ff6987, 0x2ffffffc, 0x1ffffffa, 0x3ff4186, 0x2ffffffc, 0x7ffffffa, 0x50ffffff, 0x7bffffff, 0x7e03f, 0x1fc000, 0x0, 0x403, 0x41804, 0x68182000, 0xc0000ff, 0x0, 0xc, 0x30, 0x210c]);
  
  static final List<bool> _mapping0 = _unmap([0x9]);
  
  static final List<bool> _mapping1 = _unmap([0x20000009, 0x0, 0x100000]);
  
  static final List<bool> _mapping10 = _unmap([0x1, 0x2]);
  
  static final List<bool> _mapping2 = _unmap([0x41, 0x82]);
  
  static final List<bool> _mapping3 = _unmap([0x7e03ff, 0xfc0000]);
  
  static final List<bool> _mapping4 = _unmap([0x1, 0x2]);
  
  static final List<bool> _mapping5 = _unmap([0x43ffffff, 0x7fffffe]);
  
  static final List<bool> _mapping6 = _unmap([0x1000009, 0x0, 0x100000]);
  
  static final List<bool> _mapping7 = _unmap([0x5]);
  
  static final List<bool> _mapping8 = _unmap([0x20000021, 0x8000000, 0x544046]);
  
  static final List<bool> _mapping9 = _unmap([0x800001]);
  
  static final List<int> _strings0 = <int>[100, 101, 102, 105, 110, 101, 100];
  
  static final List<int> _strings1 = <int>[38, 38];
  
  static final List<int> _strings10 = <int>[76, 76];
  
  static final List<int> _strings11 = <int>[108, 108];
  
  static final List<int> _strings12 = <int>[60, 60];
  
  static final List<int> _strings13 = <int>[60, 61];
  
  static final List<int> _strings14 = <int>[33, 61];
  
  static final List<int> _strings15 = <int>[76, 34];
  
  static final List<int> _strings16 = <int>[92, 85];
  
  static final List<int> _strings17 = <int>[92, 117];
  
  static final List<int> _strings2 = <int>[13, 10];
  
  static final List<int> _strings3 = <int>[124, 124];
  
  static final List<int> _strings4 = <int>[76, 39];
  
  static final List<int> _strings5 = <int>[61, 61];
  
  static final List<int> _strings6 = <int>[62, 61];
  
  static final List<int> _strings7 = <int>[92, 120];
  
  static final List<int> _strings8 = <int>[48, 120];
  
  static final List<int> _strings9 = <int>[48, 88];
  
  final List<String> _tokenAliases = ["\'defined\'", "additive_operator", "\'&\'", "\'&&\'", "constant", "eof", "equality_operator", "identifier", "\'(\'", "multiplicative_operator", "new_line", "\'?\'", "relational_operator", "\')\'", "\':\'", "\'<<\'", "string_literal", "unary_operator", "\'|\'", "\'||\'", "\'^\'"];
  
  final List<int> _tokenFlags = [1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
  
  final List<String> _tokenNames = ["DEFINED", "additive_operator", "ampersand", "ampersand2", "constant", "eof", "equality_operator", "identifier", "lparen", "multiplicative_operator", "new_line", "question_mark", "relational_operator", "rparen", "semicolon", "shift_operator", "string_literal", "unary_operator", "vertical_line", "vertical_line2", "xor"];
  
  static final List<List<int>> _transitions0 = [[33, 34, 39, 40, 43, 43, 45, 46, 48, 57, 65, 90, 92, 92, 95, 95, 97, 122, 126, 126]];
  
  static final List<List<int>> _transitions1 = [[0, 9, 11, 12, 14, 1114111], [10, 10, 13, 13]];
  
  static final List<List<int>> _transitions10 = [[33, 33], [61, 61]];
  
  static final List<List<int>> _transitions11 = [[65, 90, 92, 92, 95, 95, 97, 122]];
  
  static final List<List<int>> _transitions12 = [[37, 37], [42, 42], [47, 47]];
  
  static final List<List<int>> _transitions13 = [[10, 10], [13, 13]];
  
  static final List<List<int>> _transitions14 = [[60, 60], [62, 62]];
  
  static final List<List<int>> _transitions15 = [[34, 34, 76, 76]];
  
  static final List<List<int>> _transitions16 = [[33, 33], [43, 43], [45, 45], [126, 126]];
  
  static final List<List<int>> _transitions17 = [[80, 80, 112, 112]];
  
  static final List<List<int>> _transitions18 = [[80, 80], [112, 112]];
  
  static final List<List<int>> _transitions19 = [[0, 42, 44, 44, 46, 1114111], [43, 43, 45, 45]];
  
  static final List<List<int>> _transitions2 = [[33, 33, 61, 61]];
  
  static final List<List<int>> _transitions20 = [[39, 39], [76, 76]];
  
  static final List<List<int>> _transitions21 = [[39, 39, 76, 76], [46, 46], [48, 57]];
  
  static final List<List<int>> _transitions22 = [[0, 47, 58, 1114111], [48, 57]];
  
  static final List<List<int>> _transitions23 = [[46, 46, 48, 57]];
  
  static final List<List<int>> _transitions24 = [[46, 46], [48, 57]];
  
  static final List<List<int>> _transitions25 = [[69, 69, 101, 101]];
  
  static final List<List<int>> _transitions26 = [[69, 69], [101, 101]];
  
  static final List<List<int>> _transitions27 = [[70, 70, 76, 76, 102, 102, 108, 108]];
  
  static final List<List<int>> _transitions28 = [[48, 57, 65, 70, 97, 102]];
  
  static final List<List<int>> _transitions29 = [[0, 47, 58, 64, 71, 96, 103, 1114111], [48, 57, 65, 70, 97, 102]];
  
  static final List<List<int>> _transitions3 = [[60, 60, 62, 62]];
  
  static final List<List<int>> _transitions30 = [[46, 46], [48, 57, 65, 70, 97, 102]];
  
  static final List<List<int>> _transitions31 = [[0, 47, 58, 64, 91, 91, 93, 94, 96, 96, 123, 1114111], [48, 57], [65, 90, 92, 92, 95, 95, 97, 122]];
  
  static final List<List<int>> _transitions32 = [[65, 90, 95, 95, 97, 122], [92, 92]];
  
  static final List<List<int>> _transitions33 = [[48, 48], [49, 57]];
  
  static final List<List<int>> _transitions34 = [[76, 76, 108, 108], [85, 85, 117, 117]];
  
  static final List<List<int>> _transitions35 = [[76, 76], [108, 108]];
  
  static final List<List<int>> _transitions36 = [[76, 76, 108, 108]];
  
  static final List<List<int>> _transitions37 = [[65, 90, 95, 95, 97, 122]];
  
  static final List<List<int>> _transitions38 = [[0, 47, 56, 1114111], [48, 55]];
  
  static final List<List<int>> _transitions39 = [[34, 34], [76, 76]];
  
  static final List<List<int>> _transitions4 = [[43, 43, 45, 45]];
  
  static final List<List<int>> _transitions40 = [[85, 85, 117, 117]];
  
  static final List<List<int>> _transitions5 = [[37, 37, 42, 42, 47, 47]];
  
  static final List<List<int>> _transitions6 = [[33, 33, 43, 43, 45, 45, 126, 126], [34, 34, 39, 40, 46, 46, 48, 57, 65, 90, 92, 92, 95, 95, 97, 122]];
  
  static final List<List<int>> _transitions7 = [[34, 34], [39, 39, 46, 46, 48, 57], [40, 40], [65, 90], [92, 92, 95, 95, 97, 99, 101, 122], [100, 100]];
  
  static final List<List<int>> _transitions8 = [[43, 43], [45, 45]];
  
  static final List<List<int>> _transitions9 = [[39, 39, 46, 46, 48, 57, 76, 76]];
  
  List<Map<int, List>> _cache;
  
  List<int> _cachePos;
  
  List<bool> _cacheable;
  
  int _ch;
  
  int _cursor;
  
  List<ExprParserError> _errors;
  
  List<String> _expected;
  
  int _failurePos;
  
  List<int> _input;
  
  int _inputLen;
  
  int _startPos;
  
  int _testing;
  
  int _token;
  
  int _tokenStart;
  
  bool success;
  
  final String text;
  
  ExprParser(this.text) {
    if (text == null) {
      throw new ArgumentError('text: $text');
    }    
    _input = _toCodePoints(text);
    _inputLen = _input.length;    
    reset(0);    
  }
  
  void _addToCache(dynamic result, int start, int id) {   
    var map = _cache[id];
    if (map == null) {
      map = <int, List>{};
      _cache[id] = map;
    }
    map[start] = [result, _cursor, success];      
  }
  
  void _failure([List<String> expected]) {  
    if (_failurePos > _cursor) {
      return;
    }
    if (_failurePos < _cursor) {    
      _expected = [];
     _failurePos = _cursor;
    }
    if (_token != null) {
      var alias = _tokenAliases[_token];
      var flag = _tokenFlags[_token];
      var name = _tokenNames[_token];
      if (_failurePos > _tokenStart && _failurePos == _inputLen && (flag & 1) != 0) {             
        var message = "Unterminated '$name'";
        _errors.add(new ExprParserError(ExprParserError.UNTERMINATED, _failurePos, _tokenStart, message));
        _expected.addAll(expected);            
      } else if (_failurePos > _tokenStart && (flag & 1) != 0) {             
        var message = "Malformed '$name'";
        _errors.add(new ExprParserError(ExprParserError.MALFORMED, _failurePos, _tokenStart, message));
        _expected.addAll(expected);            
      } else {
        _expected.add(alias);
      }            
    } else if (expected == null) {
      _expected.add(null);
    } else {
      _expected.addAll(expected);
    }   
  }
  
  List _flatten(dynamic value) {
    if (value is List) {
      var result = [];
      var length = value.length;
      for (var i = 0; i < length; i++) {
        var element = value[i];
        if (element is Iterable) {
          result.addAll(_flatten(element));
        } else {
          result.add(element);
        }
      }
      return result;
    } else if (value is Iterable) {
      var result = [];
      for (var element in value) {
        if (element is! List) {
          result.add(element);
        } else {
          result.addAll(_flatten(element));
        }
      }
    }
    return [value];
  }
  
  dynamic _getFromCache(int id) {  
    if (!_cacheable[id]) {  
      _cacheable[id] = true;  
      return null;
    }
    var map = _cache[id];
    if (map == null) {
      return null;
    }
    var data = map[_cursor];
    if (data == null) {
      return null;
    }
    _cursor = data[1];
    success = data[2];
    if (_cursor < _inputLen) {
      _ch = _input[_cursor];
    } else {
      _ch = -1;
    }
    return data;  
  }
  
  int _getState(List<List<int>> transitions) {
    var count = transitions.length;
    var state = 0;
    for ( ; state < count; state++) {
      var found = false;
      var ranges = transitions[state];    
      while (true) {
        var right = ranges.length ~/ 2;
        if (right == 0) {
          break;
        }
        var left = 0;
        if (right == 1) {
          if (_ch <= ranges[1] && _ch >= ranges[0]) {
            found = true;          
          }
          break;
        }
        int middle;
        while (left < right) {
          middle = (left + right) >> 1;
          var index = middle << 1;
          if (ranges[index + 1] < _ch) {
            left = middle + 1;
          } else {
            if (_ch >= ranges[index]) {
              found = true;
              break;
            }
            right = middle;
          }
        }
        break;
      }
      if (found) {
        return state; 
      }   
    }
    if (_ch != -1) {
      return state;
    }
    return state + 1;  
  }
  
  List _list(Object first, List next) {
    var length = next.length;
    var list = new List(length + 1);
    list[0] = first;
    for (var i = 0; i < length; i++) {
      list[i + 1] = next[i][1];
    }
    return list;
  }
  
  String _matchAny() {
    success = _cursor < _inputLen;
    if (success) {
      String result;
      if (_ch < 128) {
        result = _ascii[_ch];  
      } else {
        result = new String.fromCharCode(_ch);
      }    
      if (++_cursor < _inputLen) {
        _ch = _input[_cursor];
      } else {
        _ch = -1;
      }    
      return result;
    }    
    return null;  
  }
  
  String _matchChar(int ch, String string) {
    success = _ch == ch;
    if (success) {
      var result = string;  
      if (++_cursor < _inputLen) {
        _ch = _input[_cursor];
      } else {
        _ch = -1;
      }    
      return result;
    }  
    return null;  
  }
  
  String _matchMapping(int start, int end, List<bool> mapping) {
    success = _ch >= start && _ch <= end;
    if (success) {    
      if(mapping[_ch - start]) {
        String result;
        if (_ch < 128) {
          result = _ascii[_ch];  
        } else {
          result = new String.fromCharCode(_ch);
        }     
        if (++_cursor < _inputLen) {
          _ch = _input[_cursor];
        } else {
          _ch = -1;
        }      
        return result;
      }
      success = false;
    }  
    return null;  
  }
  
  String _matchRange(int start, int end) {
    success = _ch >= start && _ch <= end;
    if (success) {
      String result;
      if (_ch < 128) {
        result = _ascii[_ch];  
      } else {
        result = new String.fromCharCode(_ch);
      }        
      if (++_cursor < _inputLen) {
        _ch = _input[_cursor];
      } else {
        _ch = -1;
      }  
      return result;
    }  
    return null;  
  }
  
  String _matchRanges(List<int> ranges) {
    var length = ranges.length;
    for (var i = 0; i < length; i += 2) {    
      if (_ch >= ranges[i]) {
        if (_ch <= ranges[i + 1]) {
          String result;
          if (_ch < 128) {
            result = _ascii[_ch];  
          } else {
            result = new String.fromCharCode(_ch);
          }          
          if (++_cursor < _inputLen) {
            _ch = _input[_cursor];
          } else {
             _ch = -1;
          }
          success = true;    
          return result;
        }      
      } else break;  
    }
    success = false;  
    return null;  
  }
  
  String _matchString(List<int> codePoints, String string) {
    var length = codePoints.length;  
    success = _cursor + length <= _inputLen;
    if (success) {
      for (var i = 0; i < length; i++) {
        if (codePoints[i] != _input[_cursor + i]) {
          success = false;
          break;
        }
      }
    } else {
      success = false;
    }  
    if (success) {
      _cursor += length;      
      if (_cursor < _inputLen) {
        _ch = _input[_cursor];
      } else {
        _ch = -1;
      }    
      return string;      
    }  
    return null; 
  }
  
  void _nextChar() {
    if (++_cursor < _inputLen) {
      _ch = _input[_cursor];
    } else {
      _ch = -1;
    }  
  }
  
  dynamic _parse_DEFINED() {
    var $$;
    _token = 0;  
    _tokenStart = _cursor;  
    switch (_ch == 100 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings0, 'defined');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect13);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_additive_expression() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[11] >= pos) {
      $$ = _getFromCache(11);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[11] = pos;
    }  
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_multiplicative_expression();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_getState(_transitions4)) {
              case 0:
              case 2:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  $$ = _parse_additive_operator();
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_multiplicative_expression();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect10);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = _buildBinary($1, $2);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    if (_cacheable[11]) {
      _addToCache($$, pos, 11);
    }    
    return $$;
  }
  
  dynamic _parse_additive_operator() {
    var $$;
    _token = 1;  
    _tokenStart = _cursor;  
    switch (_getState(_transitions8)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_plus();
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        _startPos = _cursor;
        $$ = _parse_minus();
        _startPos = startPos1;
        break;
      case 2:
        $$ = null;
        success = false;
        break;
      case 3:
        while (true) {
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _parse_plus();
          _startPos = startPos2;
          if (success) break;
          var startPos3 = _startPos;
          _startPos = _cursor;
          $$ = _parse_minus();
          _startPos = startPos3;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect10);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_ampersand() {
    var $$;
    _token = 2;  
    _tokenStart = _cursor;  
    switch (_ch == 38 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(38, '&');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect6);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_ampersand2() {
    var $$;
    _token = 3;  
    _tokenStart = _cursor;  
    switch (_ch == 38 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings1, '&&');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect3);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_and_expression() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[7] >= pos) {
      $$ = _getFromCache(7);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[7] = pos;
    }  
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_equality_expression();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_ch == 38 ? 0 : _ch == -1 ? 2 : 1) {
              case 0:
              case 2:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  $$ = _parse_ampersand();
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_equality_expression();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect6);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = _buildBinary($1, $2);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    if (_cacheable[7]) {
      _addToCache($$, pos, 7);
    }    
    return $$;
  }
  
  dynamic _parse_asterisk() {
    var $$;
    switch (_ch == 42 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(42, '*');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect24);
    }
    return $$;
  }
  
  dynamic _parse_binary_exponent_part() {
    var $$;
    switch (_getState(_transitions17)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          switch (_getState(_transitions18)) {
            case 0:
              var startPos1 = _startPos;
              _startPos = _cursor;
              $$ = _matchChar(80, 'P');
              _startPos = startPos1;
              break;
            case 1:
              var startPos2 = _startPos;
              _startPos = _cursor;
              $$ = _matchChar(112, 'p');
              _startPos = startPos2;
              break;
            case 2:
            case 3:
              $$ = null;
              success = false;
              break;
          }
          if (!success && _cursor > _testing) {
            _failure(_expect25);
          }
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          switch (_getState(_transitions19)) {
            case 0:
            case 3:
              var startPos3 = _startPos;
              _startPos = _cursor;
              success = true;
              $$ = '';
              _startPos = startPos3;
              break;
            case 1:
              while (true) {
                var startPos4 = _startPos;
                _startPos = _cursor;
                $$ = _parse_sign();
                _startPos = startPos4;
                if (success) break;
                var startPos5 = _startPos;
                _startPos = _cursor;
                success = true;
                $$ = '';
                _startPos = startPos5;
                break;
              }
              break;
            case 2:
              $$ = null;
              success = false;
              break;
          }
          if (!success && _cursor > _testing) {
            _failure(const [null]);
          }
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_digit_sequence();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = _text();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect25);
    }
    return $$;
  }
  
  dynamic _parse_c_char() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var ch1 = _ch, pos1 = _cursor, testing0 = _testing; 
            _testing = _inputLen + 1;
            $$ = _matchMapping(10, 92, _mapping1);
            _ch = ch1;
            _cursor = pos1; 
            _testing = testing0;
            $$ = null;
            success = !success;
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchAny();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos0;
              $$ = $2.codeUnitAt(0);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_escape_sequence();
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_character_constant_base() {
    var $$;
    switch (_getState(_transitions20)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(39, '\'');
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_c_char();
          if (!success) break;
          seq[1] = $$;
          $$ = _matchChar(39, '\'');
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = new CharacterLiteral(position: $start, text: _text(), value: $2);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings4, 'L\'');
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_c_char();
          if (!success) break;
          seq[1] = $$;
          $$ = _matchChar(39, '\'');
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos1;
            $$ = new CharacterLiteral(position: $start, text: _text(), value: $2);
          }
          break;
        }
        if (!success) {
          _ch = ch1;
          _cursor = pos1;
        }
        _startPos = startPos1;
        break;
      case 2:
        $$ = null;
        success = false;
        break;
      case 3:
        while (true) {
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchChar(39, '\'');
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _parse_c_char();
            if (!success) break;
            seq[1] = $$;
            $$ = _matchChar(39, '\'');
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos2;
              $$ = new CharacterLiteral(position: $start, text: _text(), value: $2);
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          if (success) break;
          var ch3 = _ch, pos3 = _cursor, startPos3 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchString(_strings4, 'L\'');
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _parse_c_char();
            if (!success) break;
            seq[1] = $$;
            $$ = _matchChar(39, '\'');
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos3;
              $$ = new CharacterLiteral(position: $start, text: _text(), value: $2);
            }
            break;
          }
          if (!success) {
            _ch = ch3;
            _cursor = pos3;
          }
          _startPos = startPos3;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect26);
    }
    return $$;
  }
  
  dynamic _parse_conditional_expression() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[2] >= pos) {
      $$ = _getFromCache(2);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[2] = pos;
    }  
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_logical_or_expression();
            if (!success) break;
            var seq = new List(5)..[0] = $$;
            $$ = _parse_question_mark();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_expression();
            if (!success) break;
            seq[2] = $$;
            $$ = _parse_semicolon();
            if (!success) break;
            seq[3] = $$;
            $$ = _parse_conditional_expression();
            if (!success) break;
            seq[4] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $4 = seq[3];
              final $5 = seq[4];
              final $start = startPos0;
              $$ = _conditional($1, $3, $5, $start);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_logical_or_expression();
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    if (_cacheable[2]) {
      _addToCache($$, pos, 2);
    }    
    return $$;
  }
  
  dynamic _parse_constant() {
    var $$;
    _token = 4;  
    _tokenStart = _cursor;  
    switch (_getState(_transitions9)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_constant_base();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces2();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect14);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_constant_base() {
    var $$;
    switch (_getState(_transitions21)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_character_constant_base();
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        _startPos = _cursor;
        $$ = _parse_floating_constant_base();
        _startPos = startPos1;
        break;
      case 2:
        while (true) {
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _parse_floating_constant_base();
          _startPos = startPos2;
          if (success) break;
          var startPos3 = _startPos;
          _startPos = _cursor;
          $$ = _parse_integer_constant_base();
          _startPos = startPos3;
          break;
        }
        break;
      case 3:
        $$ = null;
        success = false;
        break;
      case 4:
        while (true) {
          var startPos4 = _startPos;
          _startPos = _cursor;
          $$ = _parse_floating_constant_base();
          _startPos = startPos4;
          if (success) break;
          var startPos5 = _startPos;
          _startPos = _cursor;
          $$ = _parse_integer_constant_base();
          _startPos = startPos5;
          if (success) break;
          var startPos6 = _startPos;
          _startPos = _cursor;
          $$ = _parse_character_constant_base();
          _startPos = startPos6;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_constant_expression() {
    var $$;
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_conditional_expression();
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    return $$;
  }
  
  dynamic _parse_decimal_constant() {
    var $$;
    switch (_ch >= 49 && _ch <= 57 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_nonzero_digit();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_decimal_constant1();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = int.parse(_text());
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_decimal_constant1() {
    var $$;
    switch (_getState(_transitions22)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        success = true;
        $$ = '';
        _startPos = startPos0;
        break;
      case 1:
      case 3:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_digit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_decimal_constant1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_decimal_floating_constant() {
    var $$;
    switch (_getState(_transitions23)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_decimal_floating_constant_base();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces2();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_decimal_floating_constant_base() {
    var $$;
    switch (_getState(_transitions24)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_fractional_constant();
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_exponent_part();
          success = true; 
          _testing = testing0;
          if (!success) break;
          seq[1] = $$;
          var testing1 = _testing;
          _testing = _cursor;
          $$ = _parse_floating_suffix();
          success = true; 
          _testing = testing1;
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = _floatLiteral(_text(), $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 3:
        while (true) {
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_fractional_constant();
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            var testing2 = _testing;
            _testing = _cursor;
            $$ = _parse_exponent_part();
            success = true; 
            _testing = testing2;
            if (!success) break;
            seq[1] = $$;
            var testing3 = _testing;
            _testing = _cursor;
            $$ = _parse_floating_suffix();
            success = true; 
            _testing = testing3;
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos1;
              $$ = _floatLiteral(_text(), $start);
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          if (success) break;
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_digit_sequence();
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _parse_exponent_part();
            if (!success) break;
            seq[1] = $$;
            var testing4 = _testing;
            _testing = _cursor;
            $$ = _parse_floating_suffix();
            success = true; 
            _testing = testing4;
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos2;
              $$ = _floatLiteral(_text(), $start);
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_defined() {
    var $$;
    switch (_ch == 100 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_DEFINED();
          if (!success) break;
          var seq = new List(4)..[0] = $$;
          $$ = _parse_lparen();
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_identifier();
          if (!success) break;
          seq[2] = $$;
          $$ = _parse_rparen();
          if (!success) break;
          seq[3] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            final $start = startPos0;
            $$ = new DefinedExpression(identifier: $3, position: $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect13);
    }
    return $$;
  }
  
  dynamic _parse_digit() {
    var $$;
    switch (_ch >= 48 && _ch <= 57 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchRange(48, 57);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_digit_sequence() {
    var $$;
    switch (_ch >= 48 && _ch <= 57 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var testing0;
        for (var first = true, reps; ;) {  
          $$ = _parse_digit();  
          if (success) {
           if (first) {      
              first = false;
              reps = [$$];
              testing0 = _testing;                  
            } else {
              reps.add($$);
            }
            _testing = _cursor;   
          } else {
            success = !first;
            if (success) {      
              _testing = testing0;
              $$ = reps;      
            } else $$ = null;
            break;
          }  
        }
        if (success) {    
          final $1 = $$;
          final $start = startPos0;
          $$ = _text();
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_eof() {
    var $$;
    _token = 5;  
    _tokenStart = _cursor;  
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var ch0 = _ch, pos0 = _cursor, testing0 = _testing; 
        _testing = _inputLen + 1;
        $$ = _matchAny();
        _ch = ch0;
        _cursor = pos0; 
        _testing = testing0;
        $$ = null;
        success = !success;
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect15);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_eq() {
    var $$;
    switch (_ch == 61 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings5, '==');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect27);
    }
    return $$;
  }
  
  dynamic _parse_equality_expression() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[8] >= pos) {
      $$ = _getFromCache(8);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[8] = pos;
    }  
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_relational_expression();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_getState(_transitions2)) {
              case 0:
              case 2:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  $$ = _parse_equality_operator();
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_relational_expression();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect7);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = _buildBinary($1, $2);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    if (_cacheable[8]) {
      _addToCache($$, pos, 8);
    }    
    return $$;
  }
  
  dynamic _parse_equality_operator() {
    var $$;
    _token = 6;  
    _tokenStart = _cursor;  
    switch (_getState(_transitions10)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_neq();
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        _startPos = _cursor;
        $$ = _parse_eq();
        _startPos = startPos1;
        break;
      case 2:
        $$ = null;
        success = false;
        break;
      case 3:
        while (true) {
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _parse_eq();
          _startPos = startPos2;
          if (success) break;
          var startPos3 = _startPos;
          _startPos = _cursor;
          $$ = _parse_neq();
          _startPos = startPos3;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect7);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_escape_sequence() {
    var $$;
    switch (_ch == 92 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        while (true) {
          var startPos0 = _startPos;
          _startPos = _cursor;
          $$ = _parse_simple_escape_sequence();
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_octal_escape_sequence();
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _parse_hexadecimal_escape_sequence();
          _startPos = startPos2;
          if (success) break;
          var startPos3 = _startPos;
          _startPos = _cursor;
          $$ = _parse_universal_character_name();
          _startPos = startPos3;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
      case 2:
        var startPos4 = _startPos;
        _startPos = _cursor;
        $$ = _parse_hexadecimal_escape_sequence();
        _startPos = startPos4;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_exclamation() {
    var $$;
    switch (_ch == 33 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(33, '!');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect28);
    }
    return $$;
  }
  
  dynamic _parse_exclusive_or_expression() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[6] >= pos) {
      $$ = _getFromCache(6);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[6] = pos;
    }  
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_and_expression();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_ch == 94 ? 0 : _ch == -1 ? 2 : 1) {
              case 0:
              case 2:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  $$ = _parse_xor();
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_and_expression();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect5);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = _buildBinary($1, $2);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    if (_cacheable[6]) {
      _addToCache($$, pos, 6);
    }    
    return $$;
  }
  
  dynamic _parse_exponent_part() {
    var $$;
    switch (_getState(_transitions25)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          switch (_getState(_transitions26)) {
            case 0:
              var startPos1 = _startPos;
              _startPos = _cursor;
              $$ = _matchChar(69, 'E');
              _startPos = startPos1;
              break;
            case 1:
              var startPos2 = _startPos;
              _startPos = _cursor;
              $$ = _matchChar(101, 'e');
              _startPos = startPos2;
              break;
            case 2:
            case 3:
              $$ = null;
              success = false;
              break;
          }
          if (!success && _cursor > _testing) {
            _failure(_expect29);
          }
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          switch (_getState(_transitions19)) {
            case 0:
            case 3:
              var startPos3 = _startPos;
              _startPos = _cursor;
              success = true;
              $$ = '';
              _startPos = startPos3;
              break;
            case 1:
              while (true) {
                var startPos4 = _startPos;
                _startPos = _cursor;
                $$ = _parse_sign();
                _startPos = startPos4;
                if (success) break;
                var startPos5 = _startPos;
                _startPos = _cursor;
                success = true;
                $$ = '';
                _startPos = startPos5;
                break;
              }
              break;
            case 2:
              $$ = null;
              success = false;
              break;
          }
          if (!success && _cursor > _testing) {
            _failure(const [null]);
          }
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_digit_sequence();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = _text();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect29);
    }
    return $$;
  }
  
  dynamic _parse_expression() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[16] >= pos) {
      $$ = _getFromCache(16);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[16] = pos;
    }  
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_conditional_expression();
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    if (_cacheable[16]) {
      _addToCache($$, pos, 16);
    }    
    return $$;
  }
  
  dynamic _parse_floating_constant_base() {
    var $$;
    switch (_getState(_transitions24)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_decimal_floating_constant();
        _startPos = startPos0;
        break;
      case 1:
      case 3:
        while (true) {
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_decimal_floating_constant();
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _parse_hexadecimal_floating_constant();
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_floating_suffix() {
    var $$;
    switch (_getState(_transitions27)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(70, 108, _mapping2);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_fractional_constant() {
    var $$;
    switch (_getState(_transitions24)) {
      case 0:
      case 3:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_digit_sequence();
          success = true; 
          _testing = testing0;
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _matchChar(46, '.');
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_digit_sequence();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = _text();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        while (true) {
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var testing1 = _testing;
            _testing = _cursor;
            $$ = _parse_digit_sequence();
            success = true; 
            _testing = testing1;
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _matchChar(46, '.');
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_digit_sequence();
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos1;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          if (success) break;
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_digit_sequence();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchChar(46, '.');
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos2;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_gt() {
    var $$;
    switch (_ch == 62 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(62, '>');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect30);
    }
    return $$;
  }
  
  dynamic _parse_gte() {
    var $$;
    switch (_ch == 62 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings6, '>=');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect31);
    }
    return $$;
  }
  
  dynamic _parse_hex_quad() {
    var $$;
    switch (_getState(_transitions28)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_hexadecimal_digit();
          if (!success) break;
          var seq = new List(4)..[0] = $$;
          $$ = _parse_hexadecimal_digit();
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_hexadecimal_digit();
          if (!success) break;
          seq[2] = $$;
          $$ = _parse_hexadecimal_digit();
          if (!success) break;
          seq[3] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $4 = seq[3];
            final $start = startPos0;
            $$ = _text();
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_constant() {
    var $$;
    switch (_ch == 48 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_hexadecimal_prefix();
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_hexadecimal_digit();
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_hexadecimal_constant1();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = int.parse(_text(2), radix: 16);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect32);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_constant1() {
    var $$;
    switch (_getState(_transitions29)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        success = true;
        $$ = '';
        _startPos = startPos0;
        break;
      case 1:
      case 3:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_digit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_hexadecimal_constant1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_digit() {
    var $$;
    switch (_getState(_transitions28)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(48, 102, _mapping3);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_digit_sequence() {
    var $$;
    switch (_getState(_transitions28)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var testing0;
        for (var first = true, reps; ;) {  
          $$ = _parse_hexadecimal_digit();  
          if (success) {
           if (first) {      
              first = false;
              reps = [$$];
              testing0 = _testing;                  
            } else {
              reps.add($$);
            }
            _testing = _cursor;   
          } else {
            success = !first;
            if (success) {      
              _testing = testing0;
              $$ = reps;      
            } else $$ = null;
            break;
          }  
        }
        if (success) {    
          final $1 = $$;
          final $start = startPos0;
          $$ = _text();
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_escape_sequence() {
    var $$;
    switch (_ch == 92 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings7, '\\x');
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_hexadecimal_digit();
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_hexadecimal_escape_sequence1();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = int.parse(_text(2), radix: 16);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect33);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_escape_sequence1() {
    var $$;
    switch (_getState(_transitions29)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        success = true;
        $$ = '';
        _startPos = startPos0;
        break;
      case 1:
      case 3:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_digit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_hexadecimal_escape_sequence1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos1;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_floating_constant() {
    var $$;
    switch (_ch == 48 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_prefix();
            if (!success) break;
            var seq = new List(4)..[0] = $$;
            $$ = _parse_hexadecimal_fractional_constant();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_binary_exponent_part();
            if (!success) break;
            seq[2] = $$;
            var testing0 = _testing;
            _testing = _cursor;
            $$ = _parse_floating_suffix();
            success = true; 
            _testing = testing0;
            if (!success) break;
            seq[3] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $4 = seq[3];
              final $start = startPos0;
              $$ = _floatLiteral(_text(), $start);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_prefix();
            if (!success) break;
            var seq = new List(4)..[0] = $$;
            $$ = _parse_hexadecimal_digit_sequence();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_binary_exponent_part();
            if (!success) break;
            seq[2] = $$;
            var testing1 = _testing;
            _testing = _cursor;
            $$ = _parse_floating_suffix();
            success = true; 
            _testing = testing1;
            if (!success) break;
            seq[3] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $4 = seq[3];
              final $start = startPos1;
              $$ = _floatLiteral(_text(), $start);
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect32);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_fractional_constant() {
    var $$;
    switch (_getState(_transitions30)) {
      case 0:
      case 3:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_hexadecimal_digit_sequence();
          success = true; 
          _testing = testing0;
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _matchChar(46, '.');
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_hexadecimal_digit_sequence();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        while (true) {
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var testing1 = _testing;
            _testing = _cursor;
            $$ = _parse_hexadecimal_digit_sequence();
            success = true; 
            _testing = testing1;
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _matchChar(46, '.');
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_hexadecimal_digit_sequence();
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          if (success) break;
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_digit_sequence();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchChar(46, '.');
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_hexadecimal_prefix() {
    var $$;
    switch (_ch == 48 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        while (true) {
          var startPos0 = _startPos;
          _startPos = _cursor;
          $$ = _matchString(_strings8, '0x');
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _matchString(_strings9, '0X');
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect32);
    }
    return $$;
  }
  
  dynamic _parse_identifier() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[24] >= pos) {
      $$ = _getFromCache(24);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[24] = pos;
    }  
    _token = 7;    
    _tokenStart = _cursor;    
    switch (_getState(_transitions11)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_identifier_base();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces2();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect16);
    }
    if (_cacheable[24]) {
      _addToCache($$, pos, 24);
    }    
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_identifier_base() {
    var $$;
    switch (_getState(_transitions11)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_identifier_nondigit();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_identifier_base1();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = new Identifier(name: _text(), position: $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_identifier_base1() {
    var $$;
    switch (_getState(_transitions31)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        success = true;
        $$ = '';
        _startPos = startPos0;
        break;
      case 1:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_digit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_identifier_base1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos1;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        while (true) {
          var ch1 = _ch, pos1 = _cursor, startPos3 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_identifier_nondigit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_identifier_base1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos3;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos3;
          if (success) break;
          var startPos4 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos4;
          break;
        }
        break;
      case 3:
        $$ = null;
        success = false;
        break;
      case 4:
        while (true) {
          var ch2 = _ch, pos2 = _cursor, startPos5 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_identifier_nondigit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_identifier_base1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos5;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos5;
          if (success) break;
          var ch3 = _ch, pos3 = _cursor, startPos6 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_digit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_identifier_base1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos6;
              $$ = _text();
            }
            break;
          }
          if (!success) {
            _ch = ch3;
            _cursor = pos3;
          }
          _startPos = startPos6;
          if (success) break;
          var startPos7 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos7;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_identifier_nondigit() {
    var $$;
    switch (_getState(_transitions32)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_nondigit();
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        _startPos = _cursor;
        $$ = _parse_universal_character_name();
        _startPos = startPos1;
        break;
      case 2:
      case 3:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_inclusive_or_expression() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[5] >= pos) {
      $$ = _getFromCache(5);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[5] = pos;
    }  
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_exclusive_or_expression();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_ch == 124 ? 0 : _ch == -1 ? 2 : 1) {
              case 0:
              case 2:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  $$ = _parse_vertical_line();
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_exclusive_or_expression();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect4);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = _buildBinary($1, $2);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    if (_cacheable[5]) {
      _addToCache($$, pos, 5);
    }    
    return $$;
  }
  
  dynamic _parse_integer_constant_base() {
    var $$;
    switch (_getState(_transitions33)) {
      case 0:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_constant();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing0 = _testing;
            _testing = _cursor;
            $$ = _parse_integer_suffix();
            success = true; 
            _testing = testing0;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos0;
              $$ = new IntegerLiteral(position: $start, text: _text(), value: $1);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_octal_constant();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing1 = _testing;
            _testing = _cursor;
            $$ = _parse_integer_suffix();
            success = true; 
            _testing = testing1;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos1;
              $$ = new IntegerLiteral(position: $start, text: _text(), value: $1);
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_decimal_constant();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing2 = _testing;
          _testing = _cursor;
          $$ = _parse_integer_suffix();
          success = true; 
          _testing = testing2;
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos2;
            $$ = new IntegerLiteral(position: $start, text: _text(), value: $1);
          }
          break;
        }
        if (!success) {
          _ch = ch2;
          _cursor = pos2;
        }
        _startPos = startPos2;
        break;
      case 2:
        $$ = null;
        success = false;
        break;
      case 3:
        while (true) {
          var ch3 = _ch, pos3 = _cursor, startPos3 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_decimal_constant();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing3 = _testing;
            _testing = _cursor;
            $$ = _parse_integer_suffix();
            success = true; 
            _testing = testing3;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos3;
              $$ = new IntegerLiteral(position: $start, text: _text(), value: $1);
            }
            break;
          }
          if (!success) {
            _ch = ch3;
            _cursor = pos3;
          }
          _startPos = startPos3;
          if (success) break;
          var ch4 = _ch, pos4 = _cursor, startPos4 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_hexadecimal_constant();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing4 = _testing;
            _testing = _cursor;
            $$ = _parse_integer_suffix();
            success = true; 
            _testing = testing4;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos4;
              $$ = new IntegerLiteral(position: $start, text: _text(), value: $1);
            }
            break;
          }
          if (!success) {
            _ch = ch4;
            _cursor = pos4;
          }
          _startPos = startPos4;
          if (success) break;
          var ch5 = _ch, pos5 = _cursor, startPos5 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_octal_constant();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing5 = _testing;
            _testing = _cursor;
            $$ = _parse_integer_suffix();
            success = true; 
            _testing = testing5;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos5;
              $$ = new IntegerLiteral(position: $start, text: _text(), value: $1);
            }
            break;
          }
          if (!success) {
            _ch = ch5;
            _cursor = pos5;
          }
          _startPos = startPos5;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_integer_suffix() {
    var $$;
    switch (_getState(_transitions34)) {
      case 0:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_long_long_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing0 = _testing;
            _testing = _cursor;
            $$ = _parse_unsigned_suffix();
            success = true; 
            _testing = testing0;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_long_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing1 = _testing;
            _testing = _cursor;
            $$ = _parse_unsigned_suffix();
            success = true; 
            _testing = testing1;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        while (true) {
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_unsigned_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_long_long_suffix();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          if (success) break;
          var ch3 = _ch, pos3 = _cursor, startPos3 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_unsigned_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing2 = _testing;
            _testing = _cursor;
            $$ = _parse_long_suffix();
            success = true; 
            _testing = testing2;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch3;
            _cursor = pos3;
          }
          _startPos = startPos3;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
      case 3:
        while (true) {
          var ch4 = _ch, pos4 = _cursor, startPos4 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_unsigned_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing3 = _testing;
            _testing = _cursor;
            $$ = _parse_long_suffix();
            success = true; 
            _testing = testing3;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch4;
            _cursor = pos4;
          }
          _startPos = startPos4;
          if (success) break;
          var ch5 = _ch, pos5 = _cursor, startPos5 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_long_long_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing4 = _testing;
            _testing = _cursor;
            $$ = _parse_unsigned_suffix();
            success = true; 
            _testing = testing4;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch5;
            _cursor = pos5;
          }
          _startPos = startPos5;
          if (success) break;
          var ch6 = _ch, pos6 = _cursor, startPos6 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_long_suffix();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            var testing5 = _testing;
            _testing = _cursor;
            $$ = _parse_unsigned_suffix();
            success = true; 
            _testing = testing5;
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch6;
            _cursor = pos6;
          }
          _startPos = startPos6;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_logical_and_expression() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[4] >= pos) {
      $$ = _getFromCache(4);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[4] = pos;
    }  
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_inclusive_or_expression();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_ch == 38 ? 0 : _ch == -1 ? 2 : 1) {
              case 0:
              case 2:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  $$ = _parse_ampersand2();
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_inclusive_or_expression();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect3);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = _buildBinary($1, $2);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    if (_cacheable[4]) {
      _addToCache($$, pos, 4);
    }    
    return $$;
  }
  
  dynamic _parse_logical_or_expression() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[3] >= pos) {
      $$ = _getFromCache(3);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[3] = pos;
    }  
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_logical_and_expression();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_ch == 124 ? 0 : _ch == -1 ? 2 : 1) {
              case 0:
              case 2:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  $$ = _parse_vertical_line2();
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_logical_and_expression();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect2);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = _buildBinary($1, $2);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    if (_cacheable[3]) {
      _addToCache($$, pos, 3);
    }    
    return $$;
  }
  
  dynamic _parse_long_long_suffix() {
    var $$;
    switch (_getState(_transitions35)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchString(_strings10, 'LL');
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        _startPos = _cursor;
        $$ = _matchString(_strings11, 'll');
        _startPos = startPos1;
        break;
      case 2:
      case 3:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect34);
    }
    return $$;
  }
  
  dynamic _parse_long_suffix() {
    var $$;
    switch (_getState(_transitions36)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(76, 108, _mapping4);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_lparen() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[25] >= pos) {
      $$ = _getFromCache(25);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[25] = pos;
    }  
    _token = 8;    
    _tokenStart = _cursor;    
    switch (_ch == 40 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(40, '(');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect17);
    }
    if (_cacheable[25]) {
      _addToCache($$, pos, 25);
    }    
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_lsh() {
    var $$;
    switch (_ch == 60 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings12, '<<');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect35);
    }
    return $$;
  }
  
  dynamic _parse_lt() {
    var $$;
    switch (_ch == 60 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(60, '<');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect36);
    }
    return $$;
  }
  
  dynamic _parse_lte() {
    var $$;
    switch (_ch == 60 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings13, '<=');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect37);
    }
    return $$;
  }
  
  dynamic _parse_minus() {
    var $$;
    switch (_ch == 45 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(45, '-');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect38);
    }
    return $$;
  }
  
  dynamic _parse_multiplicative_expression() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[12] >= pos) {
      $$ = _getFromCache(12);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[12] = pos;
    }  
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_unary_expression();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_getState(_transitions5)) {
              case 0:
              case 2:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  $$ = _parse_multiplicative_operator();
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_unary_expression();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect11);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = _buildBinary($1, $2);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    if (_cacheable[12]) {
      _addToCache($$, pos, 12);
    }    
    return $$;
  }
  
  dynamic _parse_multiplicative_operator() {
    var $$;
    _token = 9;  
    _tokenStart = _cursor;  
    switch (_getState(_transitions12)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_percent();
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        _startPos = _cursor;
        $$ = _parse_asterisk();
        _startPos = startPos1;
        break;
      case 2:
        var startPos2 = _startPos;
        _startPos = _cursor;
        $$ = _parse_slash();
        _startPos = startPos2;
        break;
      case 3:
        $$ = null;
        success = false;
        break;
      case 4:
        while (true) {
          var startPos3 = _startPos;
          _startPos = _cursor;
          $$ = _parse_asterisk();
          _startPos = startPos3;
          if (success) break;
          var startPos4 = _startPos;
          _startPos = _cursor;
          $$ = _parse_slash();
          _startPos = startPos4;
          if (success) break;
          var startPos5 = _startPos;
          _startPos = _cursor;
          $$ = _parse_percent();
          _startPos = startPos5;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect11);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_neq() {
    var $$;
    switch (_ch == 33 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings14, '!=');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect39);
    }
    return $$;
  }
  
  dynamic _parse_new_line() {
    var $$;
    _token = 10;  
    _tokenStart = _cursor;  
    switch (_getState(_transitions13)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(10, 13, _mapping0);
        _startPos = startPos0;
        break;
      case 1:
        while (true) {
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _matchString(_strings2, '\r\n');
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _matchMapping(10, 13, _mapping0);
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
      case 3:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect18);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_nondigit() {
    var $$;
    switch (_getState(_transitions37)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(65, 122, _mapping5);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_nonzero_digit() {
    var $$;
    switch (_ch >= 49 && _ch <= 57 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchRange(49, 57);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_octal_constant() {
    var $$;
    switch (_ch == 48 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(48, '0');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_octal_constant1();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = int.parse(_text(), radix: 8);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect40);
    }
    return $$;
  }
  
  dynamic _parse_octal_constant1() {
    var $$;
    switch (_getState(_transitions38)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        success = true;
        $$ = '';
        _startPos = startPos0;
        break;
      case 1:
      case 3:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_octal_digit();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_octal_constant1();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos1;
          if (success) break;
          var startPos2 = _startPos;
          _startPos = _cursor;
          success = true;
          $$ = '';
          _startPos = startPos2;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_octal_digit() {
    var $$;
    switch (_ch >= 48 && _ch <= 55 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchRange(48, 55);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_octal_escape_sequence() {
    var $$;
    switch (_ch == 92 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchChar(92, '\\');
            if (!success) break;
            var seq = new List(4)..[0] = $$;
            $$ = _parse_octal_digit();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_octal_digit();
            if (!success) break;
            seq[2] = $$;
            $$ = _parse_octal_digit();
            if (!success) break;
            seq[3] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $4 = seq[3];
              final $start = startPos0;
              $$ = int.parse(_text(1), radix: 8);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchChar(92, '\\');
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _parse_octal_digit();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_octal_digit();
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos1;
              $$ = int.parse(_text(1), radix: 8);
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          if (success) break;
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchChar(92, '\\');
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_octal_digit();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos2;
              $$ = int.parse($2, radix: 8);
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          break;
        }
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect41);
    }
    return $$;
  }
  
  dynamic _parse_percent() {
    var $$;
    switch (_ch == 37 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(37, '%');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect42);
    }
    return $$;
  }
  
  dynamic _parse_plus() {
    var $$;
    switch (_ch == 43 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(43, '+');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect43);
    }
    return $$;
  }
  
  dynamic _parse_primary_expression() {
    var $$;
    switch (_getState(_transitions7)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_string_literal();
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        _startPos = _cursor;
        $$ = _parse_constant();
        _startPos = startPos1;
        break;
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos2 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_lparen();
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          $$ = _parse_expression();
          if (!success) break;
          seq[1] = $$;
          $$ = _parse_rparen();
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos2;
            $$ = new ParenthesisExpression(expression: $2, position: $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos2;
        break;
      case 3:
        while (true) {
          var startPos3 = _startPos;
          _startPos = _cursor;
          $$ = _parse_identifier();
          _startPos = startPos3;
          if (success) break;
          var startPos4 = _startPos;
          _startPos = _cursor;
          $$ = _parse_constant();
          _startPos = startPos4;
          if (success) break;
          var startPos5 = _startPos;
          _startPos = _cursor;
          $$ = _parse_string_literal();
          _startPos = startPos5;
          break;
        }
        break;
      case 4:
        var startPos6 = _startPos;
        _startPos = _cursor;
        $$ = _parse_identifier();
        _startPos = startPos6;
        break;
      case 5:
        while (true) {
          var startPos7 = _startPos;
          _startPos = _cursor;
          $$ = _parse_defined();
          _startPos = startPos7;
          if (success) break;
          var startPos8 = _startPos;
          _startPos = _cursor;
          $$ = _parse_identifier();
          _startPos = startPos8;
          break;
        }
        break;
      case 6:
        $$ = null;
        success = false;
        break;
      case 7:
        while (true) {
          var startPos9 = _startPos;
          _startPos = _cursor;
          $$ = _parse_defined();
          _startPos = startPos9;
          if (success) break;
          var startPos10 = _startPos;
          _startPos = _cursor;
          $$ = _parse_identifier();
          _startPos = startPos10;
          if (success) break;
          var startPos11 = _startPos;
          _startPos = _cursor;
          $$ = _parse_constant();
          _startPos = startPos11;
          if (success) break;
          var startPos12 = _startPos;
          _startPos = _cursor;
          $$ = _parse_string_literal();
          _startPos = startPos12;
          if (success) break;
          var ch1 = _ch, pos1 = _cursor, startPos13 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_lparen();
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _parse_expression();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_rparen();
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos13;
              $$ = new ParenthesisExpression(expression: $2, position: $start);
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos13;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect12);
    }
    return $$;
  }
  
  dynamic _parse_question_mark() {
    var $$;
    _token = 11;  
    _tokenStart = _cursor;  
    switch (_ch == 63 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(63, '?');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect19);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_relational_expression() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[9] >= pos) {
      $$ = _getFromCache(9);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[9] = pos;
    }  
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_shift_expression();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_getState(_transitions3)) {
              case 0:
              case 2:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  $$ = _parse_relational_operator();
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_shift_expression();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect8);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = _buildBinary($1, $2);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    if (_cacheable[9]) {
      _addToCache($$, pos, 9);
    }    
    return $$;
  }
  
  dynamic _parse_relational_operator() {
    var $$;
    _token = 12;  
    _tokenStart = _cursor;  
    switch (_getState(_transitions14)) {
      case 0:
        while (true) {
          var startPos0 = _startPos;
          _startPos = _cursor;
          $$ = _parse_lt();
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_lte();
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        while (true) {
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _parse_gt();
          _startPos = startPos2;
          if (success) break;
          var startPos3 = _startPos;
          _startPos = _cursor;
          $$ = _parse_gte();
          _startPos = startPos3;
          break;
        }
        break;
      case 2:
        $$ = null;
        success = false;
        break;
      case 3:
        while (true) {
          var startPos4 = _startPos;
          _startPos = _cursor;
          $$ = _parse_lt();
          _startPos = startPos4;
          if (success) break;
          var startPos5 = _startPos;
          _startPos = _cursor;
          $$ = _parse_gt();
          _startPos = startPos5;
          if (success) break;
          var startPos6 = _startPos;
          _startPos = _cursor;
          $$ = _parse_lte();
          _startPos = startPos6;
          if (success) break;
          var startPos7 = _startPos;
          _startPos = _cursor;
          $$ = _parse_gte();
          _startPos = startPos7;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect8);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_rparen() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[30] >= pos) {
      $$ = _getFromCache(30);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[30] = pos;
    }  
    _token = 13;    
    _tokenStart = _cursor;    
    switch (_ch == 41 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(41, ')');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect20);
    }
    if (_cacheable[30]) {
      _addToCache($$, pos, 30);
    }    
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_rsh() {
    var $$;
    switch (_ch == 60 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings12, '<<');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect35);
    }
    return $$;
  }
  
  dynamic _parse_s_char() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            var ch1 = _ch, pos1 = _cursor, testing0 = _testing; 
            _testing = _inputLen + 1;
            $$ = _matchMapping(10, 92, _mapping6);
            _ch = ch1;
            _cursor = pos1; 
            _testing = testing0;
            $$ = null;
            success = !success;
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _matchAny();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos0;
              $$ = $2.codeUnitAt(0);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_escape_sequence();
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_s_char_sequence() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var testing0;
        for (var first = true, reps; ;) {  
          $$ = _parse_s_char();  
          if (success) {
           if (first) {      
              first = false;
              reps = [$$];
              testing0 = _testing;                  
            } else {
              reps.add($$);
            }
            _testing = _cursor;   
          } else {
            success = !first;
            if (success) {      
              _testing = testing0;
              $$ = reps;      
            } else $$ = null;
            break;
          }  
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_semicolon() {
    var $$;
    _token = 14;  
    _tokenStart = _cursor;  
    switch (_ch == 58 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(58, ':');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect21);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_shift_expression() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[10] >= pos) {
      $$ = _getFromCache(10);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[10] = pos;
    }  
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_additive_expression();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          var testing0 = _testing; 
          for (var reps = []; ; ) {
            _testing = _cursor;
            switch (_ch == 60 ? 0 : _ch == -1 ? 2 : 1) {
              case 0:
              case 2:
                var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
                _startPos = _cursor;
                while (true) {  
                  $$ = _parse_shift_operator();
                  if (!success) break;
                  var seq = new List(2)..[0] = $$;
                  $$ = _parse_additive_expression();
                  if (!success) break;
                  seq[1] = $$;
                  $$ = seq;
                  break;
                }
                if (!success) {
                  _ch = ch1;
                  _cursor = pos1;
                }
                _startPos = startPos1;
                break;
              case 1:
                $$ = null;
                success = false;
                break;
            }
            if (!success && _cursor > _testing) {
              _failure(_expect9);
            }
            if (success) {  
              reps.add($$);
            } else {
              success = true;
              _testing = testing0;
              $$ = reps;
              break; 
            }
          }
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = _buildBinary($1, $2);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    if (_cacheable[10]) {
      _addToCache($$, pos, 10);
    }    
    return $$;
  }
  
  dynamic _parse_shift_operator() {
    var $$;
    _token = 15;  
    _tokenStart = _cursor;  
    switch (_ch == 60 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        while (true) {
          var startPos0 = _startPos;
          _startPos = _cursor;
          $$ = _parse_lsh();
          _startPos = startPos0;
          if (success) break;
          var startPos1 = _startPos;
          _startPos = _cursor;
          $$ = _parse_rsh();
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect9);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_sign() {
    var $$;
    switch (_getState(_transitions4)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(43, 45, _mapping7);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_simple_escape_sequence() {
    var $$;
    switch (_ch == 92 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(92, '\\');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _matchMapping(34, 118, _mapping8);
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = _escape($1);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_slash() {
    var $$;
    switch (_ch == 47 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(47, '/');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect44);
    }
    return $$;
  }
  
  dynamic _parse_spaces() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        var testing0 = _testing; 
        for (var reps = []; ; ) {
          _testing = _cursor;
          $$ = _matchMapping(9, 32, _mapping9);
          if (success) {  
            reps.add($$);
          } else {
            success = true;
            _testing = testing0;
            $$ = reps;
            break; 
          }
        }
        if (success) {    
          final $1 = $$;
          final $start = startPos0;
          $$ = _text();
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = true;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect45);
    }
    return $$;
  }
  
  dynamic _parse_spaces2() {
    var $$;
    switch (_ch >= 0 && _ch <= 1114111 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_spaces();
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = true;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect45);
    }
    return $$;
  }
  
  dynamic _parse_string_literal() {
    var $$;
    _token = 16;  
    _tokenStart = _cursor;  
    switch (_getState(_transitions15)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_string_literal_base();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect22);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_string_literal_base() {
    var $$;
    switch (_getState(_transitions39)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(34, '\"');
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          var testing0 = _testing;
          _testing = _cursor;
          $$ = _parse_s_char_sequence();
          success = true; 
          _testing = testing0;
          if (!success) break;
          seq[1] = $$;
          $$ = _matchChar(34, '\"');
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos0;
            $$ = _stringLiteral(_text(), $2, $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings15, 'L\"');
          if (!success) break;
          var seq = new List(3)..[0] = $$;
          var testing1 = _testing;
          _testing = _cursor;
          $$ = _parse_s_char_sequence();
          success = true; 
          _testing = testing1;
          if (!success) break;
          seq[1] = $$;
          $$ = _matchChar(34, '\"');
          if (!success) break;
          seq[2] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $3 = seq[2];
            final $start = startPos1;
            $$ = _stringLiteral(_text(), $2, $start);
          }
          break;
        }
        if (!success) {
          _ch = ch1;
          _cursor = pos1;
        }
        _startPos = startPos1;
        break;
      case 2:
        $$ = null;
        success = false;
        break;
      case 3:
        while (true) {
          var ch2 = _ch, pos2 = _cursor, startPos2 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchChar(34, '\"');
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            var testing2 = _testing;
            _testing = _cursor;
            $$ = _parse_s_char_sequence();
            success = true; 
            _testing = testing2;
            if (!success) break;
            seq[1] = $$;
            $$ = _matchChar(34, '\"');
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos2;
              $$ = _stringLiteral(_text(), $2, $start);
            }
            break;
          }
          if (!success) {
            _ch = ch2;
            _cursor = pos2;
          }
          _startPos = startPos2;
          if (success) break;
          var ch3 = _ch, pos3 = _cursor, startPos3 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchString(_strings15, 'L\"');
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            var testing3 = _testing;
            _testing = _cursor;
            $$ = _parse_s_char_sequence();
            success = true; 
            _testing = testing3;
            if (!success) break;
            seq[1] = $$;
            $$ = _matchChar(34, '\"');
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos3;
              $$ = _stringLiteral(_text(), $2, $start);
            }
            break;
          }
          if (!success) {
            _ch = ch3;
            _cursor = pos3;
          }
          _startPos = startPos3;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect46);
    }
    return $$;
  }
  
  dynamic _parse_tilde() {
    var $$;
    switch (_ch == 126 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(126, '~');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect47);
    }
    return $$;
  }
  
  dynamic _parse_unary_expression() {
    var $$;          
    var pos = _cursor;             
    if(_cachePos[13] >= pos) {
      $$ = _getFromCache(13);
      if($$ != null) {
        return $$[0];       
      }
    } else {
      _cachePos[13] = pos;
    }  
    switch (_getState(_transitions6)) {
      case 0:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_unary_operator();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_unary_expression();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = _unary($1, $2, $start);
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        _startPos = _cursor;
        $$ = _parse_primary_expression();
        _startPos = startPos1;
        break;
      case 2:
        $$ = null;
        success = false;
        break;
      case 3:
        while (true) {
          var startPos2 = _startPos;
          _startPos = _cursor;
          $$ = _parse_primary_expression();
          _startPos = startPos2;
          if (success) break;
          var ch1 = _ch, pos1 = _cursor, startPos3 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _parse_unary_operator();
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_unary_expression();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos3;
              $$ = _unary($1, $2, $start);
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos3;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    if (_cacheable[13]) {
      _addToCache($$, pos, 13);
    }    
    return $$;
  }
  
  dynamic _parse_unary_operator() {
    var $$;
    _token = 17;  
    _tokenStart = _cursor;  
    switch (_getState(_transitions16)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _parse_exclamation();
        _startPos = startPos0;
        break;
      case 1:
        var startPos1 = _startPos;
        _startPos = _cursor;
        $$ = _parse_plus();
        _startPos = startPos1;
        break;
      case 2:
        var startPos2 = _startPos;
        _startPos = _cursor;
        $$ = _parse_minus();
        _startPos = startPos2;
        break;
      case 3:
        var startPos3 = _startPos;
        _startPos = _cursor;
        $$ = _parse_tilde();
        _startPos = startPos3;
        break;
      case 4:
        $$ = null;
        success = false;
        break;
      case 5:
        while (true) {
          var startPos4 = _startPos;
          _startPos = _cursor;
          $$ = _parse_plus();
          _startPos = startPos4;
          if (success) break;
          var startPos5 = _startPos;
          _startPos = _cursor;
          $$ = _parse_minus();
          _startPos = startPos5;
          if (success) break;
          var startPos6 = _startPos;
          _startPos = _cursor;
          $$ = _parse_tilde();
          _startPos = startPos6;
          if (success) break;
          var startPos7 = _startPos;
          _startPos = _cursor;
          $$ = _parse_exclamation();
          _startPos = startPos7;
          break;
        }
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect23);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_universal_character_name() {
    var $$;
    switch (_ch == 92 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
        while (true) {
          var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchString(_strings16, '\\U');
            if (!success) break;
            var seq = new List(3)..[0] = $$;
            $$ = _parse_hex_quad();
            if (!success) break;
            seq[1] = $$;
            $$ = _parse_hex_quad();
            if (!success) break;
            seq[2] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $3 = seq[2];
              final $start = startPos0;
              $$ = int.parse(_text(2), radix: 16);
            }
            break;
          }
          if (!success) {
            _ch = ch0;
            _cursor = pos0;
          }
          _startPos = startPos0;
          if (success) break;
          var ch1 = _ch, pos1 = _cursor, startPos1 = _startPos;
          _startPos = _cursor;
          while (true) {  
            $$ = _matchString(_strings17, '\\u');
            if (!success) break;
            var seq = new List(2)..[0] = $$;
            $$ = _parse_hex_quad();
            if (!success) break;
            seq[1] = $$;
            $$ = seq;
            if (success) {    
              final $1 = seq[0];
              final $2 = seq[1];
              final $start = startPos1;
              $$ = int.parse(_text(2), radix: 16);
            }
            break;
          }
          if (!success) {
            _ch = ch1;
            _cursor = pos1;
          }
          _startPos = startPos1;
          break;
        }
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect48);
    }
    return $$;
  }
  
  dynamic _parse_unsigned_suffix() {
    var $$;
    switch (_getState(_transitions40)) {
      case 0:
        var startPos0 = _startPos;
        _startPos = _cursor;
        $$ = _matchMapping(85, 117, _mapping10);
        _startPos = startPos0;
        break;
      case 1:
      case 2:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(const [null]);
    }
    return $$;
  }
  
  dynamic _parse_vertical_line() {
    var $$;
    _token = 18;  
    _tokenStart = _cursor;  
    switch (_ch == 124 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(124, '|');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect4);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_vertical_line2() {
    var $$;
    _token = 19;  
    _tokenStart = _cursor;  
    switch (_ch == 124 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchString(_strings3, '||');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect2);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  dynamic _parse_xor() {
    var $$;
    _token = 20;  
    _tokenStart = _cursor;  
    switch (_ch == 94 ? 0 : _ch == -1 ? 2 : 1) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _matchChar(94, '^');
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          $$ = _parse_spaces();
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect5);
    }
    _token = null;
    _tokenStart = null;
    return $$;
  }
  
  String _text([int offset = 0]) {
    return new String.fromCharCodes(_input.sublist(_startPos + offset, _cursor));
  }
  
  int _toCodePoint(String string) {
    if (string == null) {
      throw new ArgumentError("string: $string");
    }
  
    var length = string.length;
    if (length == 0) {
      throw new StateError("An empty string contains no elements.");
    }
  
    var start = string.codeUnitAt(0);
    if (length == 1) {
      return start;
    }
  
    if ((start & 0xFC00) == 0xD800) {
      var end = string.codeUnitAt(1);
      if ((end & 0xFC00) == 0xDC00) {
        return (0x10000 + ((start & 0x3FF) << 10) + (end & 0x3FF));
      }
    }
  
    return start;
  }
  
  List<int> _toCodePoints(String string) {
    if (string == null) {
      throw new ArgumentError("string: $string");
    }
  
    var length = string.length;
    if (length == 0) {
      return const <int>[];
    }
  
    var codePoints = <int>[];
    codePoints.length = length;
    var i = 0;
    var pos = 0;
    for ( ; i < length; pos++) {
      var start = string.codeUnitAt(i);
      i++;
      if ((start & 0xFC00) == 0xD800 && i < length) {
        var end = string.codeUnitAt(i);
        if ((end & 0xFC00) == 0xDC00) {
          codePoints[pos] = (0x10000 + ((start & 0x3FF) << 10) + (end & 0x3FF));
          i++;
        } else {
          codePoints[pos] = start;
        }
      } else {
        codePoints[pos] = start;
      }
    }
  
    codePoints.length = pos;
    return codePoints;
  }
  
  static List<bool> _unmap(List<int> mapping) {
    var length = mapping.length;
    var result = new List<bool>(length * 31);
    var offset = 0;
    for (var i = 0; i < length; i++) {
      var v = mapping[i];
      for (var j = 0; j < 31; j++) {
        result[offset++] = v & (1 << j) == 0 ? false : true;
      }
    }
    return result;
  }
  
  List<ExprParserError> errors() {
    if (success) {
      return <ExprParserError>[];
    }
  
    String escape(int c) {
      switch (c) {
        case 10:
          return r"\n";
        case 13:
          return r"\r";
        case 09:
          return r"\t";
        case -1:
          return "";
      }
      return new String.fromCharCode(c);
    } 
    
    String getc(int position) {  
      if (position < _inputLen) {
        return "'${escape(_input[position])}'";      
      }       
      return "end of file";
    }
  
    var errors = <ExprParserError>[];
    if (_failurePos >= _cursor) {
      var set = new Set<ExprParserError>();
      set.addAll(_errors);
      for (var error in set) {
        if (error.position >= _failurePos) {
          errors.add(error);
        }
      }
      var names = new Set<String>();  
      names.addAll(_expected);
      if (names.contains(null)) {
        var string = getc(_failurePos);
        var message = "Unexpected $string";
        var error = new ExprParserError(ExprParserError.UNEXPECTED, _failurePos, _failurePos, message);
        errors.add(error);
      } else {      
        var found = getc(_failurePos);      
        var list = names.toList();
        list.sort();
        var message = "Expected ${list.join(", ")} but found $found";
        var error = new ExprParserError(ExprParserError.EXPECTED, _failurePos, _failurePos, message);
        errors.add(error);
      }        
    }
    errors.sort((a, b) => a.position.compareTo(b.position));
    return errors;  
  }
  
  dynamic parse_eval_line() {
    var $$;
    switch (_getState(_transitions0)) {
      case 0:
      case 2:
        var ch0 = _ch, pos0 = _cursor, startPos0 = _startPos;
        _startPos = _cursor;
        while (true) {  
          $$ = _parse_constant_expression();
          if (!success) break;
          var seq = new List(2)..[0] = $$;
          switch (_getState(_transitions1)) {
            case 0:
            case 3:
              var startPos1 = _startPos;
              _startPos = _cursor;
              $$ = _parse_eof();
              _startPos = startPos1;
              break;
            case 1:
              while (true) {
                var startPos2 = _startPos;
                _startPos = _cursor;
                $$ = _parse_new_line();
                _startPos = startPos2;
                if (success) break;
                var startPos3 = _startPos;
                _startPos = _cursor;
                $$ = _parse_eof();
                _startPos = startPos3;
                break;
              }
              break;
            case 2:
              $$ = null;
              success = false;
              break;
          }
          if (!success && _cursor > _testing) {
            _failure(_expect1);
          }
          if (!success) break;
          seq[1] = $$;
          $$ = seq;
          if (success) {    
            final $1 = seq[0];
            final $2 = seq[1];
            final $start = startPos0;
            $$ = $1;
          }
          break;
        }
        if (!success) {
          _ch = ch0;
          _cursor = pos0;
        }
        _startPos = startPos0;
        break;
      case 1:
        $$ = null;
        success = false;
        break;
    }
    if (!success && _cursor > _testing) {
      _failure(_expect0);
    }
    return $$;
  }
  
  void reset(int pos) {
    if (pos == null) {
      throw new ArgumentError('pos: $pos');
    }
    if (pos < 0 || pos > _inputLen) {
      throw new RangeError('pos');
    }      
    _cursor = pos;
    _cache = new List<Map<int, List>>(101);
    _cachePos = new List<int>.filled(101, -1);  
    _cacheable = new List<bool>.filled(101, false);
    _ch = -1;
    _errors = <ExprParserError>[];   
    _expected = <String>[];
    _failurePos = -1;
    _startPos = pos;        
    _testing = -1;
    _token = null;
    _tokenStart = null;  
    if (_cursor < _inputLen) {
      _ch = _input[_cursor];
    }
    success = true;    
  }
  
}

class ExprParserError {
  static const int EXPECTED = 1;    
      
  static const int MALFORMED = 2;    
      
  static const int MISSING = 3;    
      
  static const int UNEXPECTED = 4;    
      
  static const int UNTERMINATED = 5;    
      
  final int hashCode = 0;
  
  final String message;
  
  final int position;
  
  final int start;
  
  final int type;
  
  ExprParserError(this.type, this.position, this.start, this.message);
  
  bool operator ==(other) {
    if (identical(this, other)) return true;
    if (other is ExprParserError) {
      return type == other.type && position == other.position &&
      start == other.start && message == other.message;  
    }
    return false;
  }
  
}

